/*
 * Basisklassenparameter.java - Einsatz generischer Methoden
 *
 */

class Saeugetier {
   private final boolean raeuber;

   Saeugetier(boolean raeuber) {
      this.raeuber = raeuber;
   }

   void steckbrief()  {
      System.out.println(" Ich bin ein Saeugetier.");
   }

   boolean getRaeuber() {
      return raeuber;
   }
}

class Gepard extends Saeugetier {

   Gepard() {
      super(true);
   }

   void steckbrief()  {
      System.out.println(" Ich bin ein Gepard.");
   }
   void fauchen() {
      System.out.println(" Ffffffauchhhhhhh!");
   }
}

class Elefant extends Saeugetier {

   Elefant() {
      super(false);
   }

   void steckbrief()  {
      System.out.println(" Ich bin ein Elefant.");
   }
   void spritzen() {
      System.out.println(" Spriiiiiiiiiiiiitz!");
   }
}


class Basisklassenparameter {

   static void alarmieren(Saeugetier tier) {
      if (tier.getRaeuber() == true)
         System.out.println("\t Alarm! Ein Raeuber ist " +
                             "unterwegs.\n");
        else
         System.out.println("\t Entwarnung! Nur ein " + 
                             "harmloser Pflanzenfresser.\n");

     }


   public static void main(String[] args) {
      System.out.println();
   
      Saeugetier[] saeuger = new Saeugetier[4];

      for(int i = 0; i < saeuger.length; ++i)  {
         if (Math.random() < 0.5)
            saeuger[i] = new Gepard();
         else
            saeuger[i] = new Elefant();
        }

      System.out.println("\n Alle Tiere durchgehen: \n");

      for(int i = 0; i < saeuger.length; ++i) {
          saeuger[i].steckbrief();
          alarmieren(saeuger[i]);
      }
   }
}

