/*
 * SchuhschachtelDemo.java - Ableitung von parametrisierter Klasse
 *
 */

// Schuh-Hierarchie
class Schuh {
   String name;
   int groesse;
 
   Schuh(String name, int groesse) {
      this.name = name;
      this.groesse = groesse;
   }
}
class Stiefel extends Schuh {

   Stiefel(String name, int groesse) {
      super(name, groesse);
   }
}
class Slipper extends Schuh {

   Slipper(String name, int groesse) {
      super(name, groesse);
   }
}


// parametrisierte Klassen
class Schachtel<T> {
   private T inhalt;
 
   void hineinlegen(T objekt) {
      inhalt = objekt;
   }

   T herausnehmen() {
      T tmp = inhalt;
      inhalt = null;
      return tmp;
   }
} 

class Schuhschachtel<T extends Schuh> extends Schachtel<T> {
}


public class SchuhschachtelDemo {
    
   public static void main(String[] args) {
      System.out.println();

      Schuhschachtel<Stiefel> box = new Schuhschachtel<Stiefel>(); 
      box.hineinlegen(new Stiefel("Rossini", 36));
      Stiefel obj = box.herausnehmen();
      if (obj == null)
         System.out.println(" Schachtel war leer");
      else
         System.out.println(" In Schachtel gefunden: " 
                            + obj.name + ", Groesse: " + obj.groesse);
   }    
}
