/*
 * Typidentifizierung.java - Typidentifizierung im Programmcode
 *
 */

class Saeugetier {
   private final boolean raeuber;

   Saeugetier(boolean raeuber) {
      this.raeuber = raeuber;
   }

   void steckbrief()  {
      System.out.println(" Ich bin ein Saeugetier.");
   }

   boolean getRaeuber() {
      return raeuber;
   }
}

class Gepard extends Saeugetier {

   Gepard() {
      super(true);
   }

   void steckbrief()  {
      System.out.println(" Ich bin ein Gepard.");
   }
   void fauchen() {
      System.out.println(" Ffffffauchhhhhhh!");
   }
}

class Elefant extends Saeugetier {

   Elefant() {
      super(false);
   }

   void steckbrief()  {
      System.out.println(" Ich bin ein Elefant.");
   }
   void spritzen() {
      System.out.println(" Spriiiiiiiiiiiiitz!");
   }
}


class Typidentifizierung {

   public static void main(String[] args) {
      System.out.println();

      Saeugetier[] saeuger = new Saeugetier[4];

      for(int i = 0; i < saeuger.length; ++i)  {
         if (Math.random() < 0.5)
            saeuger[i] = new Gepard();
         else
            saeuger[i] = new Elefant();
        }

      System.out.println("\n Alle Tiere durchgehen: \n");

      for(int i = 0; i < saeuger.length; ++i)  {
         saeuger[i].steckbrief();

         if (saeuger[i] instanceof Gepard) {
            System.out.print("\t");
            ((Gepard) saeuger[i]).fauchen();
         }
         else if (saeuger[i] instanceof Elefant) {
            System.out.print("\t");
            ((Elefant) saeuger[i]).spritzen();
         }
         System.out.println();
      }
   }
}

