/*
 * Schnittstellen.java - Namensvererbung und Polymorphie durch Schnittstellen
 *
 */

interface Zeichenbar {
   void zeichnen();
}


abstract class Form {
   public abstract double umfang();
   public abstract double flaeche();
}

class Kreis extends Form implements Zeichenbar {
   private double radius = 1.0;

   public Kreis()            { }
   public Kreis(double r)    { this.radius = r; }

   public double getRadius() { return radius; }
   public void setRadius(double r) { 
      if (r > 0) 
         this.radius = r;
   }

   public double umfang()    { return 2 * Math.PI * radius; }
   public double flaeche()   { return Math.PI * radius * radius; }
   public void zeichnen()    { System.out.print(" o "); }
}

class Rechteck extends Form  implements Zeichenbar {
   private double breite = 1.0;
   private double laenge = 1.0;

   public Rechteck() { }
   public Rechteck(double b, double l) { 
      this.breite = b;
      this.laenge = l;
   }

   public double getBreite() { return breite; }
   public double getLaenge() { return laenge; }
   public void setBreite(double b) { 
      if (b > 0) 
         this.breite = b;
   }
   public void setLaenge(double l) { 
      if (l > 0) 
         this.laenge = l;
   }

   public double umfang()    { return 2 * (laenge + breite); }
   public double flaeche()   { return laenge * breite; }
   public void zeichnen()    { System.out.print(" # "); }
}


class Schnittstellen {
   public static void main(String[] args) {
     System.out.println();

     Zeichenbar[] zeichenelemente = new Zeichenbar[3];
     zeichenelemente[0] = new Kreis(3);
     zeichenelemente[1] = new Rechteck(10, 2);
     zeichenelemente[2] = new Kreis(12.8);

     System.out.print(" Formen zeichnen: \n\n\t");

     for(int i = 0; i < zeichenelemente.length; ++i) 
        zeichenelemente[i].zeichnen();

     System.out.println();
   }
}

