/*
 * EigeneExceptions.java - Eigene Exceptions definieren, auslsen und abfangen
 *
 */
import java.io.Console;

class NullDivisionException extends Exception {
   private double zaehler;

   public NullDivisionException() {
   }
   public NullDivisionException(String meldung) {
      super(meldung);
   }
   public NullDivisionException(String meldung, double zaehler) {
      super(meldung);
      this.zaehler = zaehler;
   }

   public double getZaehler() { return zaehler; }
}
   

public class EigeneExceptions {

   public static double division(double zaehler, double nenner) throws NullDivisionException {
      if (nenner == 0.0)
         throw new NullDivisionException("Nulldivision", zaehler);
      else
         return zaehler/nenner;
   }
    
   public static void main(String[] args)  {
      Console cons = System.console();
      cons.printf("\n");  
      
      double zaehler = 0;
      double nenner  = 0;
      double bruch   = 0;

      try {
         // Lst eine Exception aus
         zaehler = 21.3;
         nenner  = 0.0;
         bruch = division(zaehler,nenner); 
         cons.printf("\n\t %f : %f = %f",
                     zaehler, nenner, bruch);

      } catch (NullDivisionException e) {
         cons.printf(" %s\n", e.getMessage());
         cons.printf(" Zaehler war gleich: %f \n", e.getZaehler());
      }
      
      cons.printf("\n");  
   } 
}
