/*
 * CompareTo.java - Comparable implementieren
 *
 */

class Punkt implements Comparable<Punkt> {
   int x;
   int y;

   Punkt(int x, int y) {
      this.x = x;
      this.y = y;
   }

   public boolean equals(Object obj) {
    
      if (obj instanceof Punkt) {   
         Punkt p = (Punkt) obj;

         return ( (p.x == x) && (p.y == y) );  
      } else
         return false;
   }

   public int hashCode() {
      long bits = java.lang.Double.doubleToLongBits( x );
      bits ^= java.lang.Double.doubleToLongBits( y ) * 31;
      return (((int) bits) ^ ((int) (bits >> 32)));
   }

   public double abstand() {
      return Math.sqrt(x*x + y*y); 
   }

   public final int compareTo(Punkt p) {
      if (this.equals(p))
         return 0;
      else if ( this.abstand() - p.abstand() > 0.0)
         return 1;
      else
         return -1;
   }

   public String toString() {
      return new String("( " + x + " ; " + y + " )");
   }
}


public class CompareTo {
    
   public static void main(String[] args) {
      System.out.println();

      Punkt[] punkte = new Punkt[6];

      punkte[0] = new Punkt(0, 10);
      punkte[1] = new Punkt(12, 10);
      punkte[2] = new Punkt(-100, 10);
      punkte[3] = new Punkt(0, 100);
      punkte[4] = new Punkt(12, 10);
      punkte[5] = new Punkt(0, 0);

      System.out.println(" Vor Sortierung:\n");
      for(int i = 0; i < punkte.length; ++i)
         System.out.println(" " + punkte[i].abstand());    

      java.util.Arrays.sort(punkte); 

      System.out.println();
      System.out.println(" Nach Sortierung:\n");
      for(int i = 0; i < punkte.length; ++i)
         System.out.println(" " + punkte[i].abstand());    
   }   
}
