/*
 * TiefeKopie2.java
 *
 */

class Motor implements Cloneable {
   String name;
 
   Motor(String s) {
      name = s;
   }

   public Object clone() {
      try {
         return super.clone();
      } catch (CloneNotSupportedException e) { 
         return null;
      }
   }

}

class Auto implements Cloneable {
   int maxGeschw;
   String name;
   Motor motor;

   Auto(String name, String motor, int maxGeschw) {
      this.name      = name;
      this.motor     = new Motor(motor);
      this.maxGeschw = maxGeschw;
   }

   protected Object clone() {
      try {
         Auto wagen = (Auto) super.clone();
         wagen.motor = (Motor) motor.clone();
         return wagen;

      } catch (CloneNotSupportedException e) { 
         return null;
      }
   }

   public String toString() {
      return name + ", " + maxGeschw + ", " + motor.name;
   }

}


class TiefeKopie2 {
    
   public static void main(String[] args)  {
      System.out.println();
      
      System.out.println("\n Zwei Auto-Objekte\n");
      Auto wagen1 = new Auto("Porsche", "Porsche", 280);
      Auto wagen2 = new Auto("VW", "VW", 180);

      System.out.println("\t Wagen 1: " + wagen1);
      System.out.println("\t Wagen 2: " + wagen2);

      System.out.println("\n wagen2 = wagen1.clone() \n");
      wagen2 = (Auto) wagen1.clone(); 

      System.out.println("\t Wagen 1: " + wagen1);
      System.out.println("\t Wagen 2: " + wagen2);

      System.out.println("\n Wagen 2 mit neuem Motor und Hoechstgeschwindigkeit \n");
      wagen2.maxGeschw  = 120;
      wagen2.motor.name = "VW";

      System.out.println("\t Wagen 1: " + wagen1);
      System.out.println("\t Wagen 2: " + wagen2);
   }
    
}

 
