/*
 * Vergleichen.java - equals() berschreiben
 *
 */

class Punkt {
   int x;
   int y;

   Punkt(int x, int y) {
      this.x = x;
      this.y = y;
   }

   public boolean equals(Object obj) {
    
      if (obj instanceof Punkt) {   
         Punkt p = (Punkt) obj;

         return ( (p.x == x) && (p.y == y) );  
      } else
         return false;
   }

   public int hashCode() {
      long bits = java.lang.Double.doubleToLongBits( x );
      bits ^= java.lang.Double.doubleToLongBits( y ) * 31;
      return (((int) bits) ^ ((int) (bits >> 32)));
   }

   public String toString() {
      return new String("( " + x + " ; " + y + " )");
   }
}


public class Vergleichen {
    
   public static void main(String[] args) {
      System.out.println();

      Punkt p1, p2;
      Object o;

      p1 = new Punkt(1, 2);
      System.out.println(" " + p1.equals(p1));     // Ausgabe: true

      p1 = new Punkt(12, 124);
      System.out.println(" " + p1.equals(null));   // Ausgabe: false

      p1 = new Punkt(12, 124);
      o = new Object();
      System.out.println(" " + p1.equals(o));      // Ausgabe: false

      p1 = new Punkt(12, 124);
      o = p1 ;
      System.out.println(" " + p1.equals(o));      // Ausgabe: true

      p1 = new Punkt(1, 2);
      p2 = new Punkt(1, 2);
      System.out.println(" " + p1.equals(p2));     // Ausgabe: true

      p1 = new Punkt(1, 2);
      p2 = new Punkt(2, 1);
      System.out.println(" " + p1.equals(p2));     // Ausgabe: false
   }   
}
