/*
 * JavaGrep.java - Beispiel fr grep-Funktionalitt 
 *
 */

import java.io.*;
import java.util.regex.*;

public class JavaGrep {
   public static void main(String[] args) {
      Console cons = System.console();
      cons.printf("\n");
      
      if(args.length != 2) {
        cons.printf(" Falsche Anzahl Argumente in Befehlszeile \n");
        cons.printf(" Aufruf: java JavaGrep <Dateiname> <Suchausdruck>\n");
        System.exit(0);
      }

      try {
         LineNumberReader eingabe = 
                       new LineNumberReader(new FileReader(args[0]));
         String zeile;

         Pattern ausdruck = Pattern.compile(args[1]);

         while((zeile = eingabe.readLine()) != null) {
           // Datei zeilenweise durchsuchen
           Matcher m = ausdruck.matcher(zeile);

           while(m.find() == true) {
               cons.printf(" Gefunden in Zeile %d, Spalten %d-%d", 
                    eingabe.getLineNumber(), (m.start()+1), m.end());
           }
         }
      } catch(Exception e) {
         cons.printf(" %s \n", e.getMessage()); 
      } 
   }
}
