/*
 * StringSpeed.java - Geschwindigkeitsvergleich zwischen String und StringBuilder 
 *
 */

import java.util.*;

public class StringSpeed {
   public static void main(String[] args) {
      System.out.println();

      String a = "";
      String b = "Hallo"; 
      long start, ende; 

      // StringBuilder-Version
      // noch effizienter: erwartete Gre dem Konstruktor mitgeben
      StringBuilder sb = new StringBuilder();
      start = System.currentTimeMillis();

      for(int i = 0; i < 10000; i++)
         sb.append(b); 
 
      String c = sb.toString();
      ende = System.currentTimeMillis();
      System.out.println(" StringBuilder: " + (ende - start) + " ms");  

      // String-Version
      start = System.currentTimeMillis();

      for(int i = 0; i < 10000; i++)
         a += b; 

      ende = System.currentTimeMillis();
      System.out.println(" String: " + (ende - start) + " ms");
   }
}
