/*
 * Zeitgeber.java - periodisch wiederkehrende Ausfhrung von Code
 */

import java.util.Timer;
import java.util.TimerTask;

// Klasse fr periodisch aufzurufende Methode
class Nachtwaechter extends TimerTask {
   String name;

   Nachtwaechter(String n) {
      name = n;
   }

   public void run() {
      java.awt.Toolkit.getDefaultToolkit().beep();
      System.out.println(" Meldung von Wachtmeister " + name + ": Alles ruhig!");
   }
}


public class Zeitgeber {

   public static void main(String args[]) throws InterruptedException {
      System.out.println();

      Timer timer1, timer2;

      System.out.println(" Nachtwaechter beginnen Ihre Runde.\n");
      timer1 = new Timer();
      timer1.schedule(new Nachtwaechter("Jim"), 0, 2*1000);

      timer2 = new Timer();
      timer2.schedule(new Nachtwaechter("Knut"), 0, 5*1000);

      long startZeit = System.currentTimeMillis();
      long endZeit   = startZeit + 21 * 1000;

      while(endZeit > System.currentTimeMillis()) {
         if( (System.currentTimeMillis() > startZeit + 10 * 1000) && (timer1 != null) ) {
            timer1.cancel();
            timer1 = null;
            System.out.println(" Nachtwaechter Jim hat Runde beendet.");
         }

         Thread.sleep(500);
      }

      timer2.cancel();
      System.out.println(" Nachtwaechter Knut hat Runde beendet.");
   }
}
