/*
 * SortComparable.java - Verwendung von Interface Comparable mit TreeSet 
 *
 */


import java.util.*;

// Klasse fr einzufgende Elemente
class Mitglied<T extends Mitglied> implements Comparable<T> {
   String name;
   String vorname;
   int jahr;

   // Konstruktor
   Mitglied(String n, String v, int j)  {
     name = n;
     vorname = v;
     jahr = j;
   }

   // Vergleichsmethode
   public int compareTo(T obj)  {
     if(jahr < obj.jahr)
        return -1;
     if(jahr == obj.jahr)
        return 0; 
     else
        return 1;   
   }
}


public class SortComparable {
  public static void main(String[] args) {
     System.out.println();

     TreeSet<Mitglied> meinVerein = new TreeSet<Mitglied>();

     Mitglied mg;

     mg = new Mitglied("Mueller", "Peter", 2001);
     meinVerein.add(mg);
     mg = new Mitglied("Louis", "Dirk", 2000);
     meinVerein.add(mg);
     mg = new Mitglied("Meier", "Kurt", 1998);
     meinVerein.add(mg);

     Iterator<Mitglied> it = meinVerein.iterator();

     while(it.hasNext()) {
        mg = it.next(); 
        System.out.println(" " + mg.jahr + ": " + mg.name + "," 
                           + mg.vorname);
     }
  }
}
