/*
 * WortStatistik.java - Zhlen von Worthufigkeiten mit Hashtabellen 
 *
 */

import java.util.*;
import java.io.*;

public class WortStatistik {
   public static void main(String[] args) {
      Console cons = System.console();
      cons.printf("\n");
   
      if(args.length != 1) {
        cons.printf(" Falsche Anzahl Argumente in Befehlszeile \n");
        cons.printf(" Aufruf: java WortStatistik <Dateiname>\n");
        System.exit(0);
      }

      HashMap<String, Integer> statistik = new HashMap<String, Integer>(5000,0.75F);

      try {
         BufferedReader eingabe = new 
                         BufferedReader(new FileReader(args[0]));

         StreamTokenizer st = new StreamTokenizer(eingabe);
         int typ; 

         while((typ = st.nextToken()) != StreamTokenizer.TT_EOF) {
            if(st.sval == null)
	           continue;

            if(statistik.containsKey(st.sval) == false)
	           statistik.put(st.sval, 1);
            else {
	           // Wort gibt es schon -> zhler erhhen
               Integer wert = statistik.get(st.sval);
               int z = wert.intValue() + 1; 
               statistik.put(st.sval, z); 
            }
	     }
      } catch(Exception e) {
         System.out.println(e); 
      }

      cons.printf(" Gesamte Wortanzahl: " + statistik.size());

      Set<String> wrter = statistik.keySet();
      Iterator<String> it = wrter.iterator();

      while(it.hasNext()) {
         String wort  = it.next(); 
         Integer wert = statistik.get(wort); 
         cons.printf("  %s : %d\n", wort, wert.intValue());  
      }
   }
}
