/*
 * FileList.java - Bestimmt die Anzahl aller TXT-Dateien und Verzeichnisse
 *
 */

import java.io.*;

public class FileListTXT  {
   private static int dateiZaehler = 0;
   private static int verzeichnisZaehler = 0;
   private static DateiFilter filter; 

   public static void main(String[] args)  {
      Console cons = System.console();
      cons.printf("\n");
      
      File[] wurzeln = File.listRoots(); 
      filter = new DateiFilter(".txt");

      for(int i = 0; i < wurzeln.length; i++) {
         dateiZaehler = 0;
         verzeichnisZaehler = 0;

         cons.printf(" untersuche %s\n", wurzeln[i].getPath()); 

         dateiListe(wurzeln[i]);

         cons.printf(" Verzeichnisse: %s\n", verzeichnisZaehler);
         cons.printf(" Dateien      : %s\n", dateiZaehler);
      }
   }

   public static void dateiListe(File aktuell)  {
      if(aktuell == null)
         return;

      File[] liste = aktuell.listFiles(filter); 
      verzeichnisZaehler++; 

      if(liste != null) {
         for(int i = 0; i < liste.length; i++) {
            if(liste[i].isFile() == true)
               dateiZaehler++;
            else
               dateiListe(liste[i]); 
          }
      }
   }
}


class DateiFilter implements FileFilter  {
   private String ende;

   public DateiFilter(String endung) {
      ende = endung; 
   }

   public boolean accept(File dat)  {
      if(dat.isDirectory() == true)
         return true;
      else
         if(dat.getName().endsWith(ende) == true) 
            return true;
         else
            return false; 
   }
}







