/*
 * DateiKopie_Buffered.java - (Effizientes) Kopieren mit BufferedInputStream/BufferedOutputStream
 *
 */

import java.io.*;

public class DateiKopie_Buffered  {
   public static void main(String[] args)  {
      System.out.println(); 

      if(args.length != 2)  {
         System.out.println(" Falsche Anzahl Argumente in Befehlszeile");
         System.out.println(" Aufruf mit <Quelle> <Ziel>");
         System.exit(0); 
      }

      try  {
         FileInputStream ein = new FileInputStream(args[0]);
         FileOutputStream aus = new FileOutputStream(args[1]);


         BufferedInputStream eingabe = new BufferedInputStream(ein);
         BufferedOutputStream ausgabe = new BufferedOutputStream(aus); 

         int  gelesen;
         long start= System.currentTimeMillis();

         while( (gelesen = eingabe.read()) != -1)  {
            ausgabe.write(gelesen); 
         }

         long ende = System.currentTimeMillis();
         System.out.println(" Zeitverbrauch read/write: " 
                           + (ende - start) + " ms."); 

         eingabe.close();
         ausgabe.close();
      } catch(IOException e) {
         System.err.println(e.getMessage()); 
      }
   }
}

