/*
 * RandomAccess.java - Beispiel zu RandomAccessFile
 *
 */

import java.io.*;

public class RandomAccess {
  public static void main(String[] args)  {
    System.out.println(); 

    if(args.length != 1)  {
      System.out.println(" Falsche Anzahl Argumente in Befehlszeile");
      System.out.println(" Aufruf: java RandomAccess <Dateiname>");
      System.exit(0);
    }

    try  {
      RandomAccessFile datei = new RandomAccessFile(args[0], "rw");

      long lesePos = datei.getFilePointer();
      long schreibPos = datei.length(); 
      long leseEnde = datei.length(); 
      int istNum; 
      int sollNum; 

      byte[] puffer = new byte[1024];

      while(true)  {
         datei.seek(lesePos); 

         sollNum = (int) Math.min(1024, (leseEnde - lesePos)); 
         istNum = datei.read(puffer, 0, sollNum); 
         lesePos = datei.getFilePointer();

         datei.seek(schreibPos);
         datei.write(puffer, 0, istNum);
         schreibPos = datei.getFilePointer(); 

         if(istNum != 1024)  {
            datei.close(); 
            break; 
         }
      }
    } catch(Exception e)  {
         System.err.println(e.getMessage());
    }
  }
}
