/*
 * CharsetDemo - Einsatz von Charset und CharBuffer zum Einlesen
 *
 */

import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.nio.charset.*; 
import java.util.*; 

public class CharsetDemo  {
  public static void main(String[] args)  {
    Console cons = System.console();
    cons.printf("\n");    

    if(args.length != 1)  {
       cons.printf(" Falsche Anzahl Argumente in Befehlszeile");
       cons.printf(" Aufruf mit <Dateiname>");
       System.exit(0); 
    }

    try  {
       // Eingabedatei ffnen
       FileInputStream eingabeDatei = new FileInputStream(args[0]); 
       FileChannel eingabe = eingabeDatei.getChannel();

       // Standard-Zeichenkodierung nehmen
       String enc = System.getProperty("file.encoding"); 
       cons.printf(" file.encoding: %s \n", enc); 
       Charset charSet = Charset.forName(enc); 

       // Datei lesen und ausgeben
       ByteBuffer puffer = ByteBuffer.allocate(2048);

       CharBuffer charPuffer; 

       cons.printf("\n");    
       while( eingabe.read(puffer) != -1)  {
          puffer.flip(); 
          charPuffer = charSet.decode(puffer); 
          System.console().printf(charPuffer.toString()); 
          puffer.compact();
       }
    } catch(Exception e)  {
         System.err.println(e.getMessage()); 
    }
  }
}
