/*
 * DateiKopie.java - Dateikopie mit FileChannel
 */

import java.io.*;
import java.nio.*;
import java.nio.channels.*;

public class DateiKopie  {
  public static void main(String[] args)  {
    System.out.println(); 

    if(args.length != 2)  {
     System.out.println(" Falsche Anzahl Argumente in Befehlszeile");
     System.out.println(" Aufruf mit <Quelle> <Ziel>");
     System.exit(0); 
    }
    
    try  {
      // Eingabedatei ffnen
      FileInputStream eingabeDatei = new FileInputStream(args[0]); 
      FileChannel eingabe = eingabeDatei.getChannel();

      // Zieldatei ffnen
      FileOutputStream ausgabeDatei = new FileOutputStream(args[1]);
      FileChannel ausgabe = ausgabeDatei.getChannel(); 

      ByteBuffer puffer = ByteBuffer.allocate(2048); 

      while( eingabe.read(puffer) != -1)  {
         puffer.flip(); 
         ausgabe.write(puffer); 
         puffer.compact(); 
      }

      eingabeDatei.close();
      ausgabeDatei.close(); 
    } catch(Exception e) {
      System.err.println(e.getMessage()); 
    }
  }
}
