/*
 * FileLocking.java - Schreiben mit Dateisperre
 *
 */


import java.io.*;
import java.nio.*; 
import java.nio.channels.*;

public class DateiSperren {
   public static void main(String[] args)  {
      System.out.println(); 

      if(args.length != 1)  {
         System.out.println(" Falsche Anzahl Argumente in Befehlszeile");
         System.out.println(" Aufruf: java DateiSperren <Datei>");
         System.exit(0); 
      }
	 
      try  {
         // Eingabedatei ffnen
         RandomAccessFile dieDatei = new RandomAccessFile(args[0],"rw"); 
         FileChannel ausgabe = dieDatei.getChannel();

         // zu schreibende Daten
         ByteBuffer puffer;
         puffer = ByteBuffer.wrap(" Hallo Java-Freunde!".getBytes("ISO-8859-1"));

         // exklusive Sperre auf die ersten num Bytes am Dateianfang
         long num = puffer.position();  
         FileLock sperre = ausgabe.tryLock(0,num,false);

         // schreiben
         if(sperre != null)  {
            ausgabe.write(puffer);  
            sperre.release(); 
         } else
            System.out.println(" Sperre nicht mglich!"); 
      } catch(Exception e) {
         System.err.println(e.getMessage()); 
      }
   }
}
