/*
 * MeineKlasse.java - Beispiel fr eigene Serialisierung
 *
 */
 
import java.io.*;

class SpezialKlasse  {
    private int status = 5;

    public SpezialKlasse()       {  }

    public int getStatus()       { return status; }
    public void setStatus(int s) { status = s; }
}


public class MeineKlasse implements Serializable  {
   public int a             = 0;
   private SpezialKlasse b   = new SpezialKlasse();
   
   private void writeObject(ObjectOutputStream oos) throws IOException {
      oos.writeInt(a);
      oos.writeInt(b.getStatus());
   }

   private void readObject(ObjectInputStream ois) throws IOException  {
      a = ois.readInt();
      b = new SpezialKlasse();
      b.setStatus(ois.readInt());
   }

   public static void main(String[] args)  {
      System.out.println();
      
      MeineKlasse test = new MeineKlasse();
      test.a = 1;
      test.b.setStatus(11);

      try  {
         // Instanz serialisieren
         FileOutputStream fos = new  FileOutputStream("test.ser");
         ObjectOutputStream ausgabe = new  ObjectOutputStream(fos);
         ausgabe.writeObject(test);

         test.a = 2;
         test.b.setStatus(22);

         // Deserialisierung
         FileInputStream fis = new  FileInputStream("test.ser");
         ObjectInputStream eingabe = new ObjectInputStream(fis);
         test = (MeineKlasse) eingabe.readObject();

         // Testausgabe
         System.out.println(test.a);
         System.out.println(test.b.getStatus());

      } catch(Exception e)  {
         System.err.println(e.getMessage()); 
      }
 
   }
}

