/*
 * StandardAusgabe.java - Umlenken der Standardausgabe in eine JTextArea
 *
 */

import javax.swing.*; 
import java.awt.*;
import java.awt.event.*;
import java.io.*; 


public class StandardAusgabe {
   public static void main(String[] args)  {
      Fenster f = new Fenster();
      f.setVisible(true);
   }
}


class Fenster extends JFrame  {
   private JPanel contentPane;
   private BorderLayout borderLayout = new BorderLayout();
   private JTextArea anzeige; 


   public Fenster() {
      contentPane = (JPanel) this.getContentPane();
      contentPane.setLayout(borderLayout);

      anzeige = new JTextArea(); 
      contentPane.add(anzeige,BorderLayout.CENTER); 

      setSize(new  Dimension(400,200));
      setTitle("Umlenken der Standardausgabe");

      MeinPrintStream ausgabe = new MeinPrintStream(anzeige); 
      System.setOut(ausgabe); 
      System.out.println("Dieser Text erscheint in einer JTextArea"); 
      
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }
}

class MeinPrintStream extends PrintStream {
   public MeinPrintStream(JTextArea anzeige)  {
      super(new MeinOutputStream(anzeige));
   }
}

class MeinOutputStream extends OutputStream {
   private JTextArea anzeige; 

   public MeinOutputStream(JTextArea anzeige)  {
      this.anzeige = anzeige; 
   }

   public void write(int b)  {
      char c = (char) b; 
      anzeige.append(String.valueOf(c));
   }
}
