/*
 * Tokenizer.java - Zerlegen eines Eingabestreams mit StreamTokenizer
 *
 */

import java.io.*;

public class Tokenizer  {
   final static int tt_word = StreamTokenizer.TT_WORD;
   final static int tt_number = StreamTokenizer.TT_NUMBER;
   final static int tt_eof  = StreamTokenizer.TT_EOF;
   final static int tt_eol  = StreamTokenizer.TT_EOL;

   public static void main(String[] args)  {
      System.out.println();

      try  {
         FileReader datei = new FileReader(args[0]);
         BufferedReader eingabe = new BufferedReader(datei); 

         StreamTokenizer st = new StreamTokenizer(eingabe);
         st.eolIsSignificant(true); // EOL ist Token 
         int typ;

         while((typ = st.nextToken()) != tt_eof)  {
            switch(typ)  {
            case tt_word  : System.out.println(" String:"
                                             + st.sval);
                            break;
            case tt_number: System.out.println(" Zahl:" 
                                       + st.nval);
                            break;
            case tt_eol   : System.out.println(" EOL");
                            break;
            default       : break; 
            }
         }
      } catch(Exception e) { 
           System.err.println(e.getMessage());
      }
   }
}
