/* 
 * EreignisbehandlungModelle.java - Verschiedene Modelle zur Einrichtung einer Ereignisbehandlung
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class EreignisbehandlungModelle extends JFrame {
   // Hier Variablen fr Komponenten deklarieren
   private JButton schalter1;
   private JButton schalter2;
   private JButton schalter3;
   private JButton schalter4;

  
       
   public EreignisbehandlungModelle() {
      super();

      // Hauptfenster einrichten
      setTitle("Ereignisbehandlung Modelle");
      setBackground(Color.LIGHT_GRAY);
      setLayout(new GridLayout(2, 2, 10, 10));

      // Schalter 
      SchalterLauscher sl = new SchalterLauscher();
      schalter1 = new JButton("Schalter 1");
      schalter1.addActionListener(sl);
      schalter2 = new JButton("Schalter 2");
      schalter2.addActionListener(sl);

      schalter3 = new JButton("Schalter 3");
      schalter3.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            schalter3.setEnabled(false);
            schalter1.setEnabled(true);
            schalter2.setEnabled(true);
            schalter4.setEnabled(true);
         }
      });
      schalter4 = new JButton("Schalter 4");
      schalter4.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            schalterGedrueckt(e);
         }
      });

      add(schalter1);
      add(schalter2);
      add(schalter3);
      add(schalter4);



      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
   }


   // Hier Ereignisbehandlungsmethoden fr Komponenten
   private void schalterGedrueckt(ActionEvent e) {
      schalter4.setEnabled(false);
      schalter1.setEnabled(true);
      schalter2.setEnabled(true);
      schalter3.setEnabled(true);
   }


   private final class SchalterLauscher implements ActionListener {
      public void actionPerformed(ActionEvent e) {
         Object s;

         // Befehlszeichenfolge von Taste bernehmen
         s = e.getSource();
         
         if(s == schalter1) {
            schalter1.setEnabled(false);
            schalter2.setEnabled(true);
            schalter3.setEnabled(true);
            schalter4.setEnabled(true); 
         }
         else if (s == schalter2) {
            schalter2.setEnabled(false);
            schalter1.setEnabled(true);
            schalter3.setEnabled(true);
            schalter4.setEnabled(true);
         }
      }
   }


   public static void main(String args[]) {
      EreignisbehandlungModelle hauptfenster = new EreignisbehandlungModelle();
      hauptfenster.setSize(400,300);                   
      hauptfenster.setLocationRelativeTo(null);
      hauptfenster.setVisible(true); 
   }   
}
