import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.geom.Ellipse2D;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.GraphicsDevice;
import java.awt.GraphicsDevice.WindowTranslucency;
import java.awt.GraphicsEnvironment;



 public class TransparentesFenster extends JFrame 
                                       implements ChangeListener, ActionListener {
       public TransparentesFenster() {
           super("Transparentes Fenster");
           
           addComponentListener(new ComponentAdapter() {
                public void componentResized(ComponentEvent e) {
	           setShape(new Ellipse2D.Double(0,0,getWidth(),getHeight()));
               }
            });
           
           setSize(400,300);
           setUndecorated(true); // darf keine Titelleiste haben 
           setLocationRelativeTo(null); // zentrieren auf Bildschirm 
         
           JButton ende = new JButton("Beenden");
           ende.addActionListener(this);
           JSlider slider = new JSlider(10,100, 100);
           setOpacity(1.0f);
           slider.addChangeListener(this);
           
           Box box = Box.createVerticalBox(); 
           box.add( Box.createGlue()); 
           box.add(ende);
           box.add(slider);
           box.add( Box.createGlue()); 
           setLayout(new BorderLayout());
           add(box, BorderLayout.CENTER);
       }

   public void stateChanged(ChangeEvent ce) {
      JSlider slider          = (JSlider) ce.getSource();
      int undurchsichtigkeit  = slider.getValue();
      setOpacity(undurchsichtigkeit / 100.0f); 
   }

   public void actionPerformed(ActionEvent ae) {
      System.exit(0); 
   }
    
    
   public static void main(String[] args) {
      GraphicsEnvironment ge =  GraphicsEnvironment.getLocalGraphicsEnvironment();
      GraphicsDevice gd      = ge.getDefaultScreenDevice();

      boolean uniform   = gd.isWindowTranslucencySupported(WindowTranslucency.TRANSLUCENT);
    
      if(uniform) {
         TransparentesFenster fenster = new TransparentesFenster();
         fenster.setVisible(true);              
      }
   }
}


