/* 
 * JCheckBoxDemo.java - Demonstrationsprogramm fr Kontrollkstchen
 * 
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
 
public class JCheckBoxDemo extends JFrame {
   ButtonListener lauscher = new ButtonListener();
   Label label = new Label();          // Beschriftungsfeld zur Anzeige des 
                                       // aktiviert. Kontrollkstchens
   Box box = Box.createVerticalBox();  // Container fr Kontrollkstchen
   Panel panel = new Panel();          // Grundflche fr Beschriftungsfeld
   JCheckBox eins, zwei, drei;
   String checkBoxText;                // Zeichenfolge fr aktiviertes Kontrollkstchen

   public JCheckBoxDemo() {
      super();

      // Hauptfenster einrichten
      setTitle("JCheckBox-Demo");
      getContentPane().setBackground(Color.LIGHT_GRAY);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      // Layout fr Container festlegen
      getContentPane().setLayout(new BorderLayout());

      // Kontrollkstchen erzeugen:
      eins = new JCheckBox("Eins");
      zwei = new JCheckBox("Zwei");
      drei = new JCheckBox("Drei");

      // Kontrollkstchen in Grundflche einfgen
      box.add(Box.createVerticalGlue());
      box.add(eins);
      box.add(zwei);
      box.add(drei);
      box.add(Box.createVerticalGlue());

      // Ereignisempfnger registrieren
      eins.addItemListener(lauscher);
      zwei.addItemListener(lauscher);
      drei.addItemListener(lauscher);

      // Beschriftungsfeld fr aktiviertes Kontrollkstchen
      panel.setLayout(new GridLayout());
      checkBoxText = "";           // Anfnglich leeres Beschriftungsfeld 
      label.setText(checkBoxText);

      // Ausrichtung fr Beschriftungsfeld festlegen
      label.setAlignment(Label.LEFT);
      panel.add(label);

      // Grundflchen in JFrame hinzufgen
      getContentPane().add(box, BorderLayout.CENTER);
      getContentPane().add(panel, BorderLayout.SOUTH);
   }

   // Schaltflchenklicks auswerten
   class ButtonListener implements ItemListener {
      public void itemStateChanged(ItemEvent e) {
         String s = "Ausgewhlt: ";
         
         // Feststellen, welche Kontrollkstchen ausgewhlt sind
         if (eins.isSelected()) s = s + " EINS";
         if (zwei.isSelected()) s = s + " ZWEI";
         if (drei.isSelected()) s = s + " DREI";
         
         // Ergebnis in Beschriftungsfeld anzeigen
         label.setText(s);
      }
   }



   public static void main(String args[]) {
      JCheckBoxDemo hauptfenster = new JCheckBoxDemo();
      hauptfenster.setSize(300,200);
      hauptfenster.setLocation(300,300);
      hauptfenster.setVisible(true);
   }
}
