/*
 * JListDemo.java - Demonstrationsprogramm fr Listenfeld
 */ 
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.event.*;

public class JListDemo extends JFrame {
   JList<String> liste;
   JScrollPane scrollPane;
   JLabel anzeigeLabel; 
 
   public JListDemo() {
      super();

      // Hauptfenster einrichten
      setTitle("JList-Demo");
      setBackground(Color.LIGHT_GRAY);
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


      // Layout fr Container festlegen
      setLayout(new BorderLayout());
      
      // Bezeichnungsfeld fr Anzeige der ausgewhlten Elemente
      Label elabel = new Label();

      // Grundflche fr Listenfeld
      Panel lpanel = new Panel();

      // Grundflche fr Button
      Panel bpanel = new Panel();
      JButton button = new JButton("Ans Ende");
      button.addActionListener(new AktionLauscher());
      bpanel.add(button);
      
      // Listenfeld 
      liste = new JList<String>();

      // Elemente in Array eintragen und in Liste hinzufgen
      String[] elemente = {"Eins", "Zwei", "Drei", "Vier", "Fnf", "Sechs",
                           "Sieben", "Acht", "Neun", "Zehn", "Elf", "Zwlf", 
                           "Dreizehn", "Vierzehn", "Fnfzehn"};

      liste.setListData(elemente);

      // Standardeintrag auswhlen
      liste.setSelectedIndex(0);

      // Listenfeld in Grundflche einfgen
      scrollPane = new JScrollPane(liste);
      lpanel.add(scrollPane) ;

      // Ereignisempfnger registrieren
      AuswahlListener auswahlLauscher = new AuswahlListener();
      liste.addListSelectionListener(auswahlLauscher);
	  
      // Bezeichnungsfeld fr aktiviertes Optionsfeld
      Panel anzeigePanel = new Panel();
      anzeigePanel.setLayout(new GridLayout());

      // Anfnglich leeres Bezeichnungsfeld anzeigen
      anzeigeLabel = new JLabel("");

      // Bezeichnungsfeld in Panel einfgen
      anzeigePanel.add(anzeigeLabel);

      // Grundflchen in Frame hinzufgen
      add(lpanel, BorderLayout.CENTER);
      add(anzeigePanel, BorderLayout.SOUTH);
      add(bpanel, BorderLayout.EAST);
   }

   class AktionLauscher implements ActionListener {
        public AktionLauscher() {
        }

        public void actionPerformed(ActionEvent e) {
           int anzahl = liste.getModel().getSize();
           liste.setSelectedIndex(anzahl-1);
           liste.ensureIndexIsVisible(anzahl-1);
        }
    }
   
   // Listenauswahlereignisse auswerten
   class AuswahlListener implements ListSelectionListener {
      public void valueChanged(ListSelectionEvent e) {
         if(e.getValueIsAdjusting() == false) {
            JList elemente         = (JList) e.getSource();
            java.util.List auswahl = elemente.getSelectedValuesList();
            String s = "Ausgewhlt: "; 

            for(int i = 0; i < auswahl.size(); i++)
              s = s + auswahl.get(i) + " ";

            // Ergebnis in Bezeichnungsfeld anzeigen
            anzeigeLabel.setText(s);
         }       
      }
   }


   public static void main(String args[]) {
      JListDemo hauptfenster = new JListDemo();
      hauptfenster.setSize(250,250);
      hauptfenster.setLocation(200,300);
      hauptfenster.setVisible(true);
   }
}