/* 
 * JTableDemo2.java - Beispiel fr JTable mit eigenem TableModel
 *
 */


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;

public class JTableDemo2 extends JFrame  {
       
   public JTableDemo2() {
      super();

      // Hauptfenster einrichten
      setTitle("JTable Demo2"); 
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	  
      // Tabelle anlegen
      TabellenModell modell = new TabellenModell();
      JTable tabelle = new JTable(modell);
      getContentPane().add(new JScrollPane(tabelle)); 


   }




   public static void main(String args[]) {
      // Fenster erzeugen und anzeigen
      JTableDemo2 hauptfenster = new JTableDemo2();
      hauptfenster.setSize(400,200);                     
      hauptfenster.setLocation(200,300);   
      hauptfenster.setVisible(true);
   }
    
}


// eigenes Tabellenmodell fr die Daten
class TabellenModell extends AbstractTableModel {

    // Tabellendaten bereitstellen  
    Object[][] daten = {
              {"Erika","Mustermann", new Integer(24), new Boolean(false)},
              {"Dirk","Louis", new Integer(54), new Boolean(true)},
              {"Peter","Mller", new Integer(49), new Boolean(false)},
              {"Kurt","Meier", new Integer(17), new Boolean(false)},
              {"Anna","Trobo", new Integer(21), new Boolean(true)}}; 

    String[] spaltenNamen = {"Vorname", "Nachname", "Alter", "Verheiratet"}; 

    public int getRowCount() {
       return daten.length;
    }

    public int getColumnCount() {
       return spaltenNamen.length;
    }

    public String getColumnName(int num) {
       return spaltenNamen[num];
    }

    // keine Zelle ist editierbar; daher brauchen wir auch setValueAt() nicht 
    // zu implementieren
    public boolean isCellEditable(int x, int y) {
       return false;
    }

    public Object getValueAt(int x, int y) {
       return daten[x][y]; 
    }

    // Class-Objekt wird fr den DefaultRenderer verwendet
    //
    public Class getColumnClass(int num) {
       Object obj = getValueAt(0,num);
       return obj.getClass();  
    }   
}
