/* 
 * DialogDemo.java - Beispiel fr Dialoge
 *
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*; 
import javax.swing.event.*; 
import java.io.*; 
import javax.swing.colorchooser.*; 

public class DialogDemo extends JFrame implements ActionListener {
       
   public DialogDemo() {
      super();

      // Hauptfenster einrichten
      setTitle("Dialog-Demo");
      getContentPane().setLayout(new FlowLayout()); 

      // Hier Komponenten einfgen
      JPanel demo1 = erzeugeJOptionPaneDemo();
      JPanel demo2 = erzeugeJChooserDemo();
      JPanel demo3 = erzeugeJDialogDemo(); 

      getContentPane().add(demo1);
      getContentPane().add(demo2);
      getContentPane().add(demo3);

      // Fenster schlieen
      addWindowListener(new WindowLauscher());
   }

   // Hier Ereignisbehandlungsmethoden fr Komponenten
   public void actionPerformed(ActionEvent e) {
      String cmd = e.getActionCommand(); 

      if(cmd.equals("Nachricht")) {
	JOptionPane.showMessageDialog(this,"Dies ist eine Information.",
			"showMessageDialog", JOptionPane.INFORMATION_MESSAGE);
	return; 
      }

      if(cmd.equals("Frage")) {
	int antwort = JOptionPane.showConfirmDialog(this,"Kennen Sie Java?", 
		                 "showConfirmDialog", 
				 JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);

	if(antwort == JOptionPane.YES_OPTION)
	    JOptionPane.showMessageDialog(this,"Sie haben mit ja geantwortet!", 
			"showMessageDialog", JOptionPane.PLAIN_MESSAGE);
	else
	    JOptionPane.showMessageDialog(this,"Sie haben mit nein geantwortet!", 
			"showMessageDialog", JOptionPane.PLAIN_MESSAGE);


	return; 
      }

      if(cmd.equals("Eingabe")) {
	 String[] sprachen = new String[] {"C++", "C#", "Pascal", "Java", "Oberon", "Perl"}; 

	 Object auswahl = JOptionPane.showInputDialog(this,"Nennen Sie Ihre Lieblingssprache!",
			    "showInputDialog", JOptionPane.QUESTION_MESSAGE, null,
			    sprachen, "Java");

	 if(auswahl != null) 
	      JOptionPane.showMessageDialog(this,"Ihre Lieblingssprache: " + (String) auswahl, 
			"showMessageDialog", JOptionPane.PLAIN_MESSAGE);
	 else
	      JOptionPane.showMessageDialog(this,"Sie haben nichts ausgewhlt!", 
			"showMessageDialog", JOptionPane.PLAIN_MESSAGE);

	 return; 
      }

      if(cmd.equals("Whle Datei")) {
	 JFileChooser dateiAuswahl = new JFileChooser(".");
	 DateiFilter filter1 = new DateiFilter(".java","Java Dateien");
	 DateiFilter filter2 = new DateiFilter(".class","Class Dateien");
	 dateiAuswahl.addChoosableFileFilter(filter1); 
	 dateiAuswahl.addChoosableFileFilter(filter2); 

	 int status = dateiAuswahl.showOpenDialog(this); 

	 if(status == JFileChooser.APPROVE_OPTION) {
	    File datei = dateiAuswahl.getSelectedFile();

	    JOptionPane.showMessageDialog(this,"Gewhlte Datei: " + datei.getName(), 
			"Dateiauswahl", JOptionPane.INFORMATION_MESSAGE);

	 }
	 else 
	    JOptionPane.showMessageDialog(this,"Sie haben keine Datei gewhlt.",     
			"Dateiauswahl", JOptionPane.INFORMATION_MESSAGE);

	 return; 
      }

      if(cmd.equals("Whle Farbe")) {
	  Color auswahl = JColorChooser.showDialog(this,"Farbauswahl", Color.YELLOW); 

	  if(auswahl != null) 
	     getContentPane().setBackground(auswahl); 
	  else 
	    JOptionPane.showMessageDialog(this,"Sie haben keine Farbe gewhlt.",     
			"Farbauswahl", JOptionPane.INFORMATION_MESSAGE);

	 return; 
      }

      if(cmd.equals("AudioRegler")) {
	 // Aufrufvariante 1 
	 AudioDaten daten = AudioRegler.showDialog(this,"Audio-Einstellung"); 

	 /* Aufrufvariante 2
	 AudioRegler audio = new AudioRegler(this,"Audio-Einstellung", true);
	 audio.setVisible(true);

	 AudioDaten daten = audio.getAudioDaten();
	 */

	 if(daten != null) {
	     String meldung = "Lautstrke: " + daten.lautStaerke + "\n" +
		                  "Hhen     : " + daten.hoehen      + "\n" +
			              "Bsse     : " + daten.baesse;          

	     JOptionPane.showMessageDialog(this,meldung,     
			"Audio-Einstellung", JOptionPane.INFORMATION_MESSAGE);
	 }
	 else
	    JOptionPane.showMessageDialog(this,"Sie haben nichts gendert.",     
			"Audio-Regler", JOptionPane.INFORMATION_MESSAGE);

      }
   } 


   // Diese Methode erzeugt Buttons zum Aufrufen von JOptionPane-Demos
   JPanel erzeugeJOptionPaneDemo() {
      JPanel ergebnis = null;

      JButton bNachricht = new JButton("Nachricht");
      bNachricht.addActionListener(this); 

      JButton bFrage = new JButton("Frage");
      bFrage.addActionListener(this); 

      JButton bEingabe = new JButton("Eingabe");
      bEingabe.addActionListener(this); 

      ergebnis = new JPanel();
      ergebnis.add(bNachricht);
      ergebnis.add(bFrage);
      ergebnis.add(bEingabe);

      return ergebnis;
   }

   // Diese Methode erzeugt Buttons zum Aufrufen von JFileChooser/ColorChooser
   JPanel erzeugeJChooserDemo() {       
      JPanel ergebnis = null;

      JButton bFileChooser = new JButton("Whle Datei");
      bFileChooser.addActionListener(this); 

      JButton bColorChooser = new JButton("Whle Farbe");
      bColorChooser.addActionListener(this); 

      ergebnis = new JPanel();
      ergebnis.add(bFileChooser);
      ergebnis.add(bColorChooser);

      return ergebnis;
   }

   // Diese Methode erzeugt Button zum Aufrufen von JDialog-Demo
   JPanel erzeugeJDialogDemo() {
      JPanel ergebnis = null;

      ergebnis = new JPanel();

      JButton bJDialog = new JButton("AudioRegler");
      bJDialog.addActionListener(this); 
      ergebnis.add(bJDialog); 

      
      return ergebnis;
   }


   // Fenster und Anwendung schlieen
   protected static final class WindowLauscher extends WindowAdapter {
      public void windowClosing(WindowEvent e) {
         System.exit(0);
      }
   }

   public static void main(String args[]) {
      DialogDemo hauptfenster = new DialogDemo();
      hauptfenster.setSize(300,300);                     
      hauptfenster.setLocation(200,300);   
      hauptfenster.setVisible(true); 
   }   
}


// Beispiel-Klasse fr eigenen Dialog
class AudioRegler extends JDialog implements ActionListener, ChangeListener {
   private AudioDaten audioDaten; 

   private JSlider slLaut = null;
   private JSlider slBaesse = null;
   private JSlider slHoehen = null; 

   private boolean okStatus = false; 

   public AudioRegler(Frame besitzer, String titel, boolean modal) {
      super(besitzer, titel , modal); 

      setSize(300,350); 
      audioDaten = new AudioDaten(10,2,2); 
      Container cp = getContentPane();
      cp.setLayout(new FlowLayout()); 

      Box slider = erzeugeSlider();
      cp.add(slider); 

   }

   private Box erzeugeSlider() {
      Box ergebnis = new Box(BoxLayout.Y_AXIS);
      JPanel slPanel;
      JLabel label; 
      Component abstand1 = Box.createVerticalStrut(20); 
      Component abstand2 = Box.createVerticalStrut(20); 

      slPanel = new JPanel(); 
      slLaut = new JSlider(JSlider.HORIZONTAL,0,50, audioDaten.lautStaerke);
      slLaut.addChangeListener(this); 
      slLaut.setMajorTickSpacing(10);
      slLaut.setMinorTickSpacing(1); 
      slLaut.setPaintTicks(true);
      slLaut.setPaintLabels(true);
      slLaut.setBorder(BorderFactory.createEtchedBorder());
      label = new JLabel("Lautstrke");  
      slPanel.add(slLaut);
      ergebnis.add(label); 
      ergebnis.add(slPanel); 

      slPanel = new JPanel(); 
      slHoehen = new JSlider(JSlider.HORIZONTAL,0,10, audioDaten.hoehen);
      slHoehen.addChangeListener(this); 
      slHoehen.setMajorTickSpacing(5);
      slHoehen.setMinorTickSpacing(1); 
      slHoehen.setPaintTicks(true);
      slHoehen.setPaintLabels(true);
      slHoehen.setBorder(BorderFactory.createEtchedBorder());
      label = new JLabel("Hhen");  
      slPanel.add(slHoehen);
      ergebnis.add(abstand1); 
      ergebnis.add(label); 
      ergebnis.add(slPanel); 

      slPanel = new JPanel(); 
      slBaesse = new JSlider(JSlider.HORIZONTAL,0,10, audioDaten.baesse);
      slBaesse.addChangeListener(this); 
      slBaesse.setMajorTickSpacing(5);
      slBaesse.setMinorTickSpacing(1); 
      slBaesse.setPaintTicks(true);
      slBaesse.setPaintLabels(true);
      slBaesse.setBorder(BorderFactory.createEtchedBorder());
      label = new JLabel("Bsse");  
      slPanel.add(slBaesse);
      ergebnis.add(abstand2); 
      ergebnis.add(label); 
      ergebnis.add(slPanel); 


      JPanel buttons = new JPanel(); 
      JButton ok = new JButton("OK");
      ok.addActionListener(this);
      buttons.add(ok); 
      ergebnis.add(buttons);
      return ergebnis; 
   }


   public AudioDaten getAudioDaten() {
      if(okStatus == true)
         return audioDaten;
      else
         return null;
   }

   public static AudioDaten showDialog(Frame f, String titel)  {
      AudioRegler audio = new AudioRegler(f,titel,true); 
      audio.setVisible(true);
      return audio.getAudioDaten(); 
   }

   public void stateChanged(ChangeEvent e) {
     JSlider sl = (JSlider) e.getSource();

     if(!sl.getValueIsAdjusting()) {
	int wert = (int) sl.getValue();

	if(sl == slLaut)
          audioDaten.lautStaerke = wert;

	if(sl == slHoehen)
          audioDaten.hoehen = wert;

	if(sl == slBaesse)
          audioDaten.baesse = wert;

     }
   }

   public void actionPerformed(ActionEvent e) {
      okStatus = true; // OK-Button gedrckt  
      setVisible(false); 
   }

}

// Hilfsklasse fr Audio-Daten
class AudioDaten {
  public int lautStaerke;
  public int hoehen;
  public int baesse; 

  AudioDaten(int l, int h, int b) {
     lautStaerke = l;
     hoehen = h;
     baesse = b; 
  }
}


// Eigene Dateifilter-Klasse
class DateiFilter extends javax.swing.filechooser.FileFilter  {
   private String beschreibung;        
   private String endung; 

   DateiFilter(String endung, String beschreibung) {
      this.endung = endung;
      this.beschreibung = beschreibung;
   }

   public String getDescription() {
      return beschreibung; 
   }

   // Verzeichnisse und Dateien der eingestellten Endung durchlassen
   public boolean accept(File datei) {
      if(datei.isDirectory() == true) 
	 return true;
      else 
         return (datei.getName().endsWith(endung)); 
   }
}



