/**
 * InterneFensterDemo.java  - Beispiel fr JInternalFrame 
 */

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import javax.swing.DefaultDesktopManager;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.UIManager;

public class InterneFensterDemo extends JFrame {

    public InterneFensterDemo() {
        super();
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setTitle("Interne Fenster Demo");
        this.setSize(new Dimension(700,300));
      
       
        JDesktopPane desktop = new JDesktopPane();
        desktop.setDesktopManager(new DefaultDesktopManager());
        desktop.setBackground(Color.WHITE);
        setContentPane(desktop);

        JInternalFrame kind1 = this.erzeugeInternesFenster(new Point(50,50), "Fenster 1");
        JInternalFrame kind2 = this.erzeugeInternesFenster(new Point(400,50), "Fenster 2");

        desktop.add(kind1);
        desktop.add(kind2);
    }

    
    private JInternalFrame erzeugeInternesFenster(Point pos, String name) {
        JInternalFrame fenster = new JInternalFrame(name);
        fenster.setLocation(pos);
        fenster.setIconifiable(true);
        fenster.setMaximizable(true);
        fenster.setClosable(true);
        fenster.setBackground(Color.LIGHT_GRAY);
        fenster.setSize(250,150);
        fenster.setVisible(true);
        
        return fenster;
    }

    public static void main(String[] args) {
        
        try { // interne Fenster sollen auch wie Windows-Fenster aussehen
          UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());              
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
        
        InterneFensterDemo fenster = new InterneFensterDemo();
        fenster.setVisible(true);
    }
}
