/* 
 * ModaleDialoge.java - Demonstriert verschiedene Varianten modaler Dialoge
 *
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*; 
import javax.swing.event.*; 

class Hauptfenster extends JFrame  {
   JLabel lb;
   JFrame parent;
       
   public Hauptfenster(String titel) {
      super();
      parent = this;

      // Hauptfenster einrichten
      setTitle(titel);
      setResizable(false);
      getContentPane().setLayout(null); 
      
      lb = new JLabel("----------------------");
      lb.setBounds(new Rectangle(100, 20, 300, 30));
      lb.setHorizontalAlignment(SwingConstants.CENTER);

      JButton button1 = new JButton("An");
      button1.setBounds(new Rectangle(25, 200, 75, 30));
      button1.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             lb.setText("An");
          }
      });
      JButton button2a = new JButton("DOCUMENT_MODAL-Dialog");
      button2a.setBounds(new Rectangle(125, 200, 250, 30));
      button2a.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             JDialog dialog = new JDialog(parent, ("DOCUMENT_MODAL-Dialog von " + parent.getTitle()));
             dialog.setModalityType(Dialog.ModalityType.DOCUMENT_MODAL);
             dialog.setSize(400,100);
             dialog.setLocationRelativeTo(parent);
             dialog.setVisible(true);
          }
      });
      JButton button2b = new JButton("APPLICATION_MODAL-Dialog");
      button2b.setBounds(new Rectangle(125, 150, 250, 30));
      button2b.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             JDialog dialog = new JDialog(parent, ("APPLICATION_MODAL-Dialog von " + parent.getTitle()));
             dialog.setModalityType(Dialog.ModalityType.APPLICATION_MODAL);
             dialog.setSize(400,100);
             dialog.setLocationRelativeTo(parent);
             dialog.setVisible(true);
          }
      });
      JButton button2c = new JButton("MODELESS-Dialog");
      button2c.setBounds(new Rectangle(125, 100, 250, 30));
      button2c.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             JDialog dialog = new JDialog(parent, ("MODELESS-Dialog " + parent.getTitle()));
             dialog.setModalityType(Dialog.ModalityType.MODELESS);
             dialog.setSize(400,100);
             dialog.setLocationRelativeTo(parent);
             dialog.setVisible(true);
          }
      });
      JButton button3 = new JButton("Aus");
      button3.setBounds(new Rectangle(400, 200, 75, 30));
      button3.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             lb.setText("Aus");
          }
      });

      getContentPane().add(lb);
      getContentPane().add(button1);
      getContentPane().add(button2a);
      getContentPane().add(button2b);
      getContentPane().add(button2c);
      getContentPane().add(button3);

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }
}


public class ModaleDialoge {
   public static void main(String args[]) {
      Hauptfenster fenster1 = new Hauptfenster("Erstes Hauptfenster");
      fenster1.setSize(500, 300);                     
      fenster1.setLocation(200, 200);   
      fenster1.setVisible(true); 
      
      Hauptfenster fenster2 = new Hauptfenster("Zweites Hauptfenster");
      fenster2.setSize(500, 300);                     
      fenster2.setLocation(200, 600);   
      fenster2.setVisible(true); 
   }   
}
