/*
 * Bildbetrachter.java - Bilder laden und anzeigen
 *
 */

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.filechooser.FileFilter;

import java.awt.event.*;
import java.io.*;
import java.awt.image.BufferedImage;
import javax.imageio.*;


public class Bildbetrachter extends JFrame {
   static Bildbetrachter fenster;
   String dateiname;                    // Name der Bilddatei
   BufferedImage  bild;                 // Referenz auf das aktuelle Bild
   BildLeinwand leinwand;               // JPanel zum Anzeigen des Bildes


   JMenuBar menuleiste = new JMenuBar();

   JMenu     menuDatei               = new JMenu();
   JMenuItem menuDateiOeffnen        = new JMenuItem();
   JMenuItem menuDateiBeenden        = new JMenuItem();

   // Innere Klasse zum berschreiben von paintComponent()
   class BildLeinwand extends JPanel {

      public void paintComponent(Graphics g) {
         super.paintComponent(g);

         Graphics2D g2 = (Graphics2D) g;

         if(bild != null) {
     
            int r = Math.max(getWidth()/3, getHeight()/3);
            Point mitte = new Point(getWidth()/2, getHeight()/2);

            GeneralPath kreisClip = new GeneralPath();
            kreisClip.moveTo(mitte.x, mitte.y-r);
            kreisClip.quadTo(mitte.x+r, mitte.y-r, mitte.x+r, mitte.y);
            kreisClip.quadTo(mitte.x+r, mitte.y+r, mitte.x, mitte.y+r);
            kreisClip.quadTo(mitte.x-r, mitte.y+r, mitte.x-r, mitte.y);
            kreisClip.quadTo(mitte.x-r, mitte.y-r, mitte.x, mitte.y-r);
            g2.clip(kreisClip);    
        
            g2.drawImage(bild, 0, 0, bild.getWidth(), bild.getHeight(), this);
         }
      }

      public Dimension getPreferredSize() {
         if (bild != null)
            return new Dimension(bild.getWidth(), bild.getHeight());
         else 
            return fenster.getSize();
      }
   }


   Bildbetrachter() {
      super();

      // Hauptfenster einrichten
      setTitle("Bildbetrachter");
      getContentPane().setBackground(Color.LIGHT_GRAY);

      // Menleiste
      JMenuBar menueleiste = new JMenuBar();
      menuDatei.setText("Datei");
      menuDateiOeffnen.setText("ffnen");
      menuDateiOeffnen.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            bildOeffnen();
         }
      });
      menuDateiBeenden.setText("Beenden");
      menuDateiBeenden.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            System.exit(0);
         }
      });
      menuDatei.add(menuDateiOeffnen);
      menuDatei.addSeparator();
      menuDatei.add(menuDateiBeenden);
      menueleiste.add(menuDatei);

      setJMenuBar(menueleiste);


      // Eine Leinwand anlegen (von JPanel abgeleitet)
      leinwand  = new BildLeinwand();
      getContentPane().add(leinwand, BorderLayout.CENTER);
  

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }


   // Ereignisbehandlungsmethoden fr Komponenten

   protected void bildOeffnen() {

      class PngFilter extends FileFilter {

         public String getDescription() {
            return "Portable Network Graphic (*.png)";
         }

         public boolean accept(File f) {
            if (f == null)
               return false;
            if (f.isDirectory())
               return true;
            return f.getName().toLowerCase().endsWith(".png");
         }
      }

      JFileChooser oeffnenDialog = new JFileChooser();
      oeffnenDialog.setCurrentDirectory(new File("."));
      oeffnenDialog.setFileFilter(new PngFilter());
      oeffnenDialog.setAcceptAllFileFilterUsed(false);

      if (JFileChooser.APPROVE_OPTION == oeffnenDialog.showOpenDialog(this)) {
         this.dateiname = oeffnenDialog.getSelectedFile().getPath();

         try {
            bild = ImageIO.read(new File(dateiname));

            leinwand.repaint();
            pack();

         } catch(IOException e) {
            dateiname = null;
            bild     = null;
         }
      }
   }


   public static void main(String args[]) {

      Bildbetrachter fenster = new Bildbetrachter();
      fenster.setSize(500, 500);                   
      fenster.setLocation(200,300);   
      fenster.setVisible(true); 
   }
    
}






