/* 
 * Freihand.java - MouseDragged-Ereignisse
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

public class Freihand extends javax.swing.JFrame {
   private Leinwand leinwand;
   private JPanel   schalterfeld;
   private JButton  btnLoeschen;

   private Point startpunkt, endpunkt;


   // innere Klasse fr Zeichenflche
   private class Leinwand extends JPanel {

      public Leinwand() {
         addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
               startpunkt = new Point(e.getX(), e.getY());

               Graphics g = getGraphics();
               g.fillOval(startpunkt.x-2, startpunkt.y-2, 4, 4);
               g.dispose();
            }
            public void mouseReleased(MouseEvent e) {
               endpunkt = new Point(e.getX(), e.getY());
               repaint();
            }
         });

         addMouseMotionListener(new MouseMotionAdapter() {
            public void mouseDragged(MouseEvent e) {
               endpunkt = new Point(e.getX(), e.getY());
               leinwand.repaint();
            }
         });
      }
      
      public void paintComponent(Graphics g) {
         super.paintComponent(g);

         if(endpunkt != null)
            g.drawLine(startpunkt.x, startpunkt.y, endpunkt.x, endpunkt.y);
      }
   }

       
   public Freihand() {
      // Hauptfenster einrichten
      setTitle("Zeichnen mit der Maus");
      getContentPane().setBackground(Color.LIGHT_GRAY);
     
      // JPanel fr Leinwand
      leinwand = new Leinwand();
      leinwand.setBorder(BorderFactory.createEtchedBorder());
      leinwand.setBackground(Color.WHITE);

      // Schalterfeld
      schalterfeld = new JPanel();
      btnLoeschen = new JButton("Lschen");
      btnLoeschen.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            startpunkt = null;
            endpunkt   = null;
            leinwand.repaint();
         }
      });
      schalterfeld.add(btnLoeschen);

      getContentPane().add(leinwand, BorderLayout.CENTER);
      getContentPane().add(schalterfeld, BorderLayout.SOUTH);

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }



   public static void main(String args[]) {
      Freihand hauptfenster = new Freihand();
      hauptfenster.setSize(400,300);                     
      hauptfenster.setLocation(200,300);   
      hauptfenster.setVisible(true); 
   }
    
}
