/* 
 * Grafik_Swing.java - Zeichnen in Swing-Komponenten
 * 
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Grafik_Swing extends javax.swing.JFrame {
   String ausgabe;

   // innere Klasse fr Zeichenflche
   private class Leinwand extends JPanel {
      
      public void paintComponent(Graphics g) {
         super.paintComponent(g);

         int x,y;

         g.setColor(Color.RED);
         g.setFont(new Font("Georgia", Font.ITALIC, 30));

         FontMetrics fm = g.getFontMetrics();

         x = (this.getWidth() - fm.stringWidth(ausgabe)) / 2;
         if (x < 0)
            x = 0;

         y = (this.getHeight() - fm.getLeading()) / 2;
         if (y < 0)
            y = 0;

         g.drawString(ausgabe, x, y);
      }
   }

       
   public Grafik_Swing() {
      ausgabe = "Hallo Programmierer!";

      // Hauptfenster einrichten
      setTitle("Grafikdemo");
      getContentPane().setBackground(Color.LIGHT_GRAY);
     
      getContentPane().add(new Leinwand(), BorderLayout.CENTER);

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }


   public static void main(String args[]) {
      Grafik_Swing hauptfenster = new Grafik_Swing();
      hauptfenster.setSize(400,300);                     
      hauptfenster.setLocation(200,300);   
      hauptfenster.setVisible(true); 
   }
    
}
