import java.awt.AWTEvent;
import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RadialGradientPaint;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import javax.swing.JComponent;
import javax.swing.JLayer;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.plaf.LayerUI;

class LayerUIKlasse extends LayerUI<JPanel> {
   private boolean zeichneKreis = false;
   private Point mausPosition;
    
   public LayerUIKlasse() {
   }
    
   public void installUI(JComponent comp) {
      super.installUI(comp);
      JLayer jlayer = (JLayer) comp;
     
      jlayer.setLayerEventMask(AWTEvent.MOUSE_EVENT_MASK |
                               AWTEvent.MOUSE_MOTION_EVENT_MASK);
   }

   public void uninstallUI(JComponent comp) {
      JLayer jlayer = (JLayer) comp;
      jlayer.setLayerEventMask(0);
      super.uninstallUI(comp);
   }

   protected void processMouseEvent(MouseEvent e, JLayer layer) {
      switch(e.getID()) {
         case MouseEvent.MOUSE_ENTERED: zeichneKreis = true;
                                        break;
         case MouseEvent.MOUSE_EXITED : zeichneKreis = false;
                                        break;
         default : 
      }
        
      layer.repaint();
   }

   protected void processMouseMotionEvent(MouseEvent event, JLayer layer) {
      mausPosition = SwingUtilities.convertPoint(event.getComponent(), 
                                                 event.getPoint(), layer);
      layer.repaint();
   }
  
   public void paint (Graphics g, JComponent c) {
  
      super.paint (g, c);

      if (zeichneKreis) {
         Graphics2D g2 = (Graphics2D)g.create();

         // Male Kreis mit Gradient
         float radius = 50;
         float[] dist = {0.0f, 1.0f};
         Color[] farben = {new Color(0.0f, 0.0f, 0.0f, 0.0f), Color.BLACK};
         RadialGradientPaint gradientPaint = new RadialGradientPaint(mausPosition, radius, dist, farben);
         g2.setPaint(gradientPaint);
         g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, .6f));
         g2.fillRect(0, 0, c.getWidth(), c.getHeight());
         g2.dispose();
      }
  }
}