/*
 * Javedi_Fenster.java - Hauptfenster des Editors
 *
 */

package javedi;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.util.Hashtable;

public class Javedi_Fenster extends JFrame {
   private boolean geaendert = false;                  // noch nicht gespeicherte nderungen
   private String aktDateiname = null;                 // Name der aktuellen Datei
   private int suchPosition = 0;                       // zur Untersttzung der Suche
   private Hashtable<Object, Action> aktionen;                 // fr Zwischenablagebefehle

   // Dialoge fr die Anwendung
   Fontdialog fontDialog = new Fontdialog(this);
   Suchdialog suchDialog = new Suchdialog(this);
   Javedi_Infodialog infoDialog = new Javedi_Infodialog(this);
   JFileChooser oeffnenDialog = new JFileChooser();


   // Menleiste
   JMenuBar menuleiste = new JMenuBar();

   JMenu     menuDatei               = new JMenu();
   JMenuItem menuDateiNeu            = new JMenuItem();
   JMenuItem menuDateiOeffnen        = new JMenuItem();
   JMenuItem menuDateiSpeichern      = new JMenuItem();
   JMenuItem menuDateiSpeichernUnter = new JMenuItem();
   JMenuItem menuDateiBeenden        = new JMenuItem();

   JMenu     menuBearbeiten              = new JMenu();
   JMenuItem menuBearbeitenAussschneiden = new JMenuItem();
   JMenuItem menuBearbeitenKopieren      = new JMenuItem();
   JMenuItem menuBearbeitenEinfuegen     = new JMenuItem();
   JMenuItem menuBearbeitenSuchen        = new JMenuItem();
   JMenuItem menuBearbeitenWeitersuchen  = new JMenuItem();

   JMenu     menuFormat              = new JMenu();
   JMenuItem menuFormatSchriftart    = new JMenuItem();

   JMenu     menuInfo                = new JMenu();
   JMenuItem menuInfoAbout           = new JMenuItem();

   // Symbolleiste
   JToolBar symbolleiste = new JToolBar();

   JButton btnNeu                    = new JButton();
   JButton btnOeffnen                = new JButton();
   JButton btnSpeichern              = new JButton();
   JButton btnAusschneiden           = new JButton();
   JButton btnKopieren               = new JButton();
   JButton btnEinfuegen              = new JButton();
   JToggleButton btnFett             = new JToggleButton();
   JToggleButton btnKursiv           = new JToggleButton();

   // Textfeld
   JScrollPane bildlauf  = new JScrollPane();
   JTextArea textfeld    = new JTextArea();

   // Statusleiste
   JLabel statusleiste   = new JLabel();


   /*
    * Konstruktor
    *
    */
   public Javedi_Fenster() {
      super();

      // Hauptfenster einrichten
      setTitle("Javedi-Editor");
      getContentPane().setBackground(Color.LIGHT_GRAY);
      setSize(new Dimension(500, 400));

      // Anwendungssymbol
      java.net.URL tmp = Javedi_Fenster.class.getResource("symbol.gif");
      if (tmp != null)
         setIconImage(Toolkit.getDefaultToolkit().createImage(tmp));

      // Befehle fr die Zwischenablage einlesen
      aktionen = new Hashtable<Object, Action>();
      Action[] actionsArray = textfeld.getActions();
      for (int i = 0; i < actionsArray.length; i++) {
         Action a = actionsArray[i];
         aktionen.put(a.getValue(Action.NAME), a);
      }


      // Menleiste einrichten
      menuleiste = erzeugeMenueLeiste();     
      setJMenuBar(menuleiste);

      // Symbolleiste einrichten
      symbolleiste = erzeugeSymbolLeiste(); 
      getContentPane().add(symbolleiste, BorderLayout.NORTH); 

      // Textfeld einrichten
      textfeld.setLineWrap(true);
      textfeld.setWrapStyleWord(true);
      textfeld.setBackground(Color.WHITE);
      textfeld.setText("Dies ist ein Text");
      textfeld.setFont(new Font("SansSerif", Font.PLAIN, 20));

      bildlauf.getViewport().add(textfeld, null);
      getContentPane().add(bildlauf, BorderLayout.CENTER);


      // Statusleiste einrichten
      statusleiste.setText(" ");
      getContentPane().add(statusleiste, BorderLayout.SOUTH);


      // Lauscher fr Fenster- und Dokumentereignisse
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);


      // Anwendung mit neuem, leeren Dokument starten
      dateiNeu();
   }


   /*
    * Menleiste erzeugen
    *
    */
   private JMenuBar erzeugeMenueLeiste()  {
      JMenuBar menueleiste = new JMenuBar();

      menuDatei.setText("Datei");
      menuDateiNeu.setText("Neu");
      menuDateiNeu.setAccelerator(KeyStroke.getKeyStroke('N',Event.CTRL_MASK));
      menuDateiNeu.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dateiNeu();
        }
      });
      menuDateiOeffnen.setText("ffnen");
      menuDateiOeffnen.setAccelerator(KeyStroke.getKeyStroke('O',Event.CTRL_MASK));
      menuDateiOeffnen.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dateiOeffnen();
         }
      });
      menuDateiSpeichern.setText("Speichern");
      menuDateiSpeichern.setEnabled(false);
      menuDateiSpeichern.setAccelerator(KeyStroke.getKeyStroke('S',Event.CTRL_MASK));
      menuDateiSpeichern.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dateiSpeichern();
         }
      });
      menuDateiSpeichernUnter.setText("Speichern unter");
      menuDateiSpeichernUnter.setEnabled(false);
      menuDateiSpeichernUnter.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dateiSpeichernUnter();
         }
      });
      menuDateiBeenden.setText("Beenden");
      menuDateiBeenden.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dateiBeenden();
         }
      });
      menuDatei.add(menuDateiNeu);
      menuDatei.add(menuDateiOeffnen);
      menuDatei.add(menuDateiSpeichern);
      menuDatei.add(menuDateiSpeichernUnter);
      menuDatei.addSeparator();
      menuDatei.add(menuDateiBeenden);
      menueleiste.add(menuDatei);

      menuBearbeiten.setText("Bearbeiten");
      menuBearbeitenAussschneiden.setText("Ausschneiden");
      menuBearbeitenAussschneiden.setAccelerator(KeyStroke.getKeyStroke('X',Event.CTRL_MASK));
      menuBearbeitenAussschneiden.addActionListener(aktionen.get(DefaultEditorKit.cutAction));

      menuBearbeitenKopieren.setText("Kopieren");
      menuBearbeitenKopieren.setAccelerator(KeyStroke.getKeyStroke('C',Event.CTRL_MASK));
      menuBearbeitenKopieren.addActionListener(aktionen.get(DefaultEditorKit.copyAction));

      menuBearbeitenEinfuegen.setText("Einfgen");
      menuBearbeitenEinfuegen.setAccelerator(KeyStroke.getKeyStroke('V',Event.CTRL_MASK));
      menuBearbeitenEinfuegen.addActionListener(aktionen.get(DefaultEditorKit.pasteAction));

      menuBearbeitenSuchen.setText("Suchen");
      menuBearbeitenSuchen.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            bearbeitenSuchen(0);
         }
      });

      menuBearbeitenWeitersuchen.setText("Weitersuchen");
      menuBearbeitenWeitersuchen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0));
      menuBearbeitenWeitersuchen.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            bearbeitenSuchen(suchPosition);
         }
      });
      menuBearbeiten.add(menuBearbeitenAussschneiden);
      menuBearbeiten.add(menuBearbeitenKopieren);
      menuBearbeiten.add(menuBearbeitenEinfuegen);
      menuBearbeiten.addSeparator();
      menuBearbeiten.add(menuBearbeitenSuchen);
      menuBearbeiten.add(menuBearbeitenWeitersuchen);
      menueleiste.add(menuBearbeiten);

      menuFormat.setText("Format");
      menuFormatSchriftart.setText("Schriftart");
      menuFormatSchriftart.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            formatSchriftart();
        }
      });
      menuFormat.add(menuFormatSchriftart);
      menueleiste.add(menuFormat);

      menuInfo.setText("Info");
      menuInfoAbout.setText("Info-Dialog");
      menuInfoAbout.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
           infoAbout();
         }
      });
      menuInfo.add(menuInfoAbout);
      menueleiste.add(menuInfo);

      return menueleiste; 
   }


   /*
    * Symbolleiste erzeugen
    *
    */
   private JToolBar erzeugeSymbolLeiste() {
      JToolBar symbolleiste = new JToolBar();

      // Symbolleiste
      btnNeu.setToolTipText("Neue Datei");
      btnNeu.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("New16.gif")));
      btnNeu.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             dateiNeu();
          }
      });
      btnOeffnen.setToolTipText("Datei ffnen");
      btnOeffnen.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Open16.gif")));
      btnOeffnen.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             dateiOeffnen();
          }
      });
      btnSpeichern.setToolTipText("Datei speichern");
      btnSpeichern.setEnabled(false);
      btnSpeichern.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Save16.gif")));
      btnSpeichern.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             dateiSpeichern();
          }
      });
      btnAusschneiden.setToolTipText("Ausschneiden");
      btnAusschneiden.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Cut16.gif")));
      btnAusschneiden.addActionListener(aktionen.get(DefaultEditorKit.cutAction));
      btnKopieren.setToolTipText("Kopieren");
      btnKopieren.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Copy16.gif")));
      btnKopieren.addActionListener(aktionen.get(DefaultEditorKit.copyAction));
      btnEinfuegen.setToolTipText("Einfuegen");
      btnEinfuegen.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Paste16.gif")));
      btnEinfuegen.addActionListener(aktionen.get(DefaultEditorKit.pasteAction));

      btnFett.setToolTipText("Fett");
      btnFett.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Bold16.gif")));
      btnFett.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             formatFett();
          }
      });
      btnKursiv.setToolTipText("Kursiv");
      btnKursiv.setIcon(new ImageIcon(javedi.Javedi_Fenster.class.getResource("Italic16.gif")));
      btnKursiv.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
             formatKursiv();
          }
      });

      symbolleiste.add(btnNeu);
      symbolleiste.add(btnOeffnen);
      symbolleiste.add(btnSpeichern);
      symbolleiste.add(btnAusschneiden);
      symbolleiste.addSeparator();
      symbolleiste.add(btnKopieren);
      symbolleiste.add(btnEinfuegen);
      symbolleiste.addSeparator();
      symbolleiste.add(btnFett);
      symbolleiste.add(btnKursiv);

      return symbolleiste;
   }
 

   /* 
    * Ereignisbehandlungsmethoden
    *
    */

   protected void dateiNeu() {

      if (nichtsZuSpeichern()) {
         PlainDocument dokument = new PlainDocument();
         dokument.addDocumentListener(new DokumentAdapter());
         textfeld.setDocument(dokument);

         aktDateiname = null;

         geaendert = false;
         menuDateiSpeichern.setEnabled(false);
         menuDateiSpeichernUnter.setEnabled(false);
         btnSpeichern.setEnabled(false);

         fensterTitelAnpassen();
         statusleiste.setText("Neue Datei wurde geffnet.");
      }
   }

   protected void dateiOeffnen() {
      if (!nichtsZuSpeichern()) {
         return;
      }

      if (JFileChooser.APPROVE_OPTION == oeffnenDialog.showOpenDialog(this)) {
         this.aktDateiname = oeffnenDialog.getSelectedFile().getPath();
         try {

            // Text aus Datei einlesen
            File datei = new File(aktDateiname);
            FileReader in = new FileReader(datei);
            textfeld.read(in, datei);
            in.close();

            PlainDocument dokument = (PlainDocument) textfeld.getDocument();
            dokument.addDocumentListener(new DokumentAdapter());
 
            geaendert = false;
            menuDateiSpeichern.setEnabled(false);
            menuDateiSpeichernUnter.setEnabled(false);
            btnSpeichern.setEnabled(false);
 
            statusleiste.setText(this.aktDateiname + " wurde geffnet.");
            fensterTitelAnpassen();
 
         } catch (IOException e) {
            statusleiste.setText("Fehler beim ffnen von " + this.aktDateiname);
         }
      }
   }


   protected boolean dateiSpeichern() {
      if (aktDateiname == null) {
         return dateiSpeichernUnter();
      }

      try {
         
         // Text in Datei schreiben
         File datei = new File(aktDateiname);
         FileWriter out = new FileWriter(datei);
         textfeld.write(out);
         out.close();
    
         // Editor konfigurieren
         geaendert = false;
         menuDateiSpeichern.setEnabled(false);
         menuDateiSpeichernUnter.setEnabled(false);
         btnSpeichern.setEnabled(false);

         statusleiste.setText("Gespeichert in " + aktDateiname);
         fensterTitelAnpassen();

         return true;
      } catch (IOException e) {
         statusleiste.setText("Fehler beim Speichern von " + aktDateiname);
      }
      return false;
   }


   protected boolean dateiSpeichernUnter() {
      if (JFileChooser.APPROVE_OPTION == oeffnenDialog.showSaveDialog(this)) {
         aktDateiname = oeffnenDialog.getSelectedFile().getPath();
         return dateiSpeichern();
      } else {
         return false;
      }
   }


   protected void dateiBeenden() {
      if (nichtsZuSpeichern()) 
         System.exit(0);
   }

   protected void processWindowEvent(WindowEvent e) {
      super.processWindowEvent(e);
      if (e.getID() == WindowEvent.WINDOW_CLOSING) 
         dateiBeenden();
   }


   protected void bearbeitenSuchen(int pos) {
      if (pos == 0) {
         suchDialog.setLocation((getLocation().x + 100),
                                (getLocation().y + 100));
         suchDialog.setVisible(true);
      }

      String suchbegriff = suchDialog.getSuchbegriff();

      if(suchbegriff == null)
         return;
        
      // Text zum Durchsuchen in String-Objekt speichern
      String text = textfeld.getText();
      int index = text.indexOf(suchbegriff, pos);

      if(index == -1) {
         JOptionPane.showMessageDialog(null,"String nicht gefunden",
                                     "Meldung",JOptionPane.INFORMATION_MESSAGE);
         suchPosition = 0;
      } else {
         // Den String hervorheben
         textfeld.grabFocus();
         textfeld.setCaretPosition(index);
         textfeld.moveCaretPosition(index + suchbegriff.length());
         suchPosition = index + suchbegriff.length();
      }
   }


   protected void formatSchriftart() {
      fontDialog.setLocation((getLocation().x + 100),
                             (getLocation().y + 100));
      fontDialog.setVisible(true);

      Font f = fontDialog.getSchriftart();
      if (f != null)
         textfeld.setFont(f);
   }

   protected void formatFett() {
      Font f = textfeld.getFont();
      String name = f.getFontName();
      int groesse = f.getSize();
      int stil    = f.getStyle();

      if( btnFett.isSelected() ) 
         stil |= Font.BOLD;
      else
         stil ^= Font.BOLD;

      textfeld.setFont(f.deriveFont(stil));
   }

   protected void formatKursiv() {
      Font f = textfeld.getFont();
      String name = f.getFontName();
      int groesse = f.getSize();
      int stil    = f.getStyle();

      if( btnKursiv.isSelected() )
         stil |= Font.ITALIC;
      else
         stil ^= Font.ITALIC;

      textfeld.setFont(f.deriveFont(stil));
   }

   protected void infoAbout() {
      infoDialog.setLocation((getLocation().x + 100),
                             (getLocation().y + 100));
      infoDialog.setVisible(true);
   }


   class DokumentAdapter implements javax.swing.event.DocumentListener {

      private void wenngeaendert() {
         geaendert = true;
         menuDateiSpeichern.setEnabled(true);
         menuDateiSpeichernUnter.setEnabled(true);
         btnSpeichern.setEnabled(true);
      }

      public void changedUpdate(DocumentEvent e) {
         if (!geaendert) {
            wenngeaendert();
         }
      }
      public void insertUpdate(DocumentEvent e) {
         if (!geaendert) {
            wenngeaendert();
         }
      }
      public void removeUpdate(DocumentEvent e) {
         if (!geaendert) {
            wenngeaendert();
         }
      }
   }


   /*
    * Hilfsmethoden
    *
    */

   // Anzeige des Dateinamens in der Titelleiste des Fensters
   private void fensterTitelAnpassen() {
      String titel;

      if (aktDateiname == null)
         titel = "Unbenannt";
      else
         titel = aktDateiname;

      titel = "Javedi-Editor - " + titel;
      this.setTitle(titel);
   }

   // Prfen, ob nicht gespeicherte nderungen vorliegen
   private boolean nichtsZuSpeichern() {
      if (!geaendert) {
         return true;
      }

      int option = JOptionPane.showConfirmDialog(this, "nderungen speichern?",
                                     "Texteditor", JOptionPane.YES_NO_CANCEL_OPTION);
      switch (option) {
      case JOptionPane.YES_OPTION:   return dateiSpeichern(); // nderungen speichern
      case JOptionPane.NO_OPTION:    return true;             // nderungen verwerfen
      case JOptionPane.CANCEL_OPTION:
      default:                       return false;            // Abbrechen
      }
   }

}
