/* 
 * DateiDrag.java - Datei-Drop fr JTextArea-Komponenten
 *
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DateiDrag extends JFrame {
   private JScrollPane scrollpane;
   private JTextArea   textfeld;

   public DateiDrag() {

      // Hauptfenster konfigurieren
      setTitle("Datei-Drag fr JTextArea");
      getContentPane().setBackground(Color.LIGHT_GRAY);

      // Scrollbare JTextArea einrichten
      scrollpane = new JScrollPane();
      textfeld = new JTextArea();
      scrollpane.getViewport().add(textfeld, null);

      // Drag-Support fr JTextArea aktivieren
      textfeld.setDragEnabled(true);
      
      // Drop-Modus einstellen
      textfeld.setDropMode(DropMode.INSERT);
      
      // TransferHandler fr Dateien registrieren
      textfeld.setTransferHandler(new FileTransferHandler());
 
 
      getContentPane().add(scrollpane, BorderLayout.CENTER);

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }
  
   public static void main(String args[]) {
      DateiDrag hauptfenster = new DateiDrag();
      hauptfenster.setSize(500,300);    
      hauptfenster.setLocation(300,300);    
      hauptfenster.setVisible(true); 
   }  
}
