/* 
 * Drag-and-Drop fr Labels
 *
 * @author Dirk Louis
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DragAndDrop extends JFrame {
   private JLabel lb;
   private JTextArea ta;

       
   public DragAndDrop() {
      super();

      // Hauptfenster einrichten
      setTitle("Drag&Drop fr Labels");
      setLayout(null);
      getContentPane().setBackground(Color.LIGHT_GRAY);

      // JLabel
      lb = new JLabel("Label, das Drag&Drop untersttzt");
      lb.setBounds(20, 20, 400, 30);
      lb.setBorder(BorderFactory.createCompoundBorder(
                                BorderFactory.createEtchedBorder(),
                                BorderFactory.createEmptyBorder(5,5,5,5)));
      lb.setTransferHandler(new TransferHandler("text"));
      lb.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                JComponent c = (JComponent) e.getSource();
                TransferHandler th = c.getTransferHandler();
                th.exportAsDrag(c, e, TransferHandler.COPY);
            }
      });


      // JTextArea
      ta = new JTextArea("Textfeld, das Drag&Drop untersttzt");
      ta.setBounds(20, 100, 400, 150);

      // Drag-Support fr JTextArea aktivieren
      ta.setDragEnabled(true);
      // Drop-Modus einstellen
      ta.setDropMode(DropMode.INSERT);

      getContentPane().add(lb);
      getContentPane().add(ta);

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }

   // Hier Ereignisbehandlungsmethoden fr Komponenten


   public static void main(String args[]) {
      // Fenster erzeugen und anzeigen
      DragAndDrop  hauptfenster = new DragAndDrop();
      hauptfenster.setSize(500, 300);                     
      hauptfenster.setLocation(300,300);   
      hauptfenster.setVisible(true);
   }
    
}

