/*
 * Fontdialog.java - Dialog zur Auswahl einer Schriftart
 *
 */

package javedi;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Fontdialog extends JDialog implements ActionListener {
   private Font ausgewaehlterFont;

   private List fontListe = new List();
   private List groessenListe = new List();
   private JCheckBox btnFett = new JCheckBox();
   private JCheckBox btnKursiv = new JCheckBox();
   private JButton btnOK = new JButton();
   private JButton btnAbbrechen = new JButton();

   public Fontdialog(JFrame f)  {
      super(f);
      this.setTitle("Schriftart auswhlen");
      this.setResizable(false);
      this.setSize(new Dimension(386, 265));
      this.setModal(true);
      this.getContentPane().setLayout(null);

      // Font-Liste mit auf System installierten Fonts fllen
      String fonts[] = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
      fontListe.setBounds(new Rectangle(14, 10, 244, 159));
      for(int i = 0; i < fonts.length; ++i)
         fontListe.add(fonts[i]);
      fontListe.select(0);

      // Gren-Liste mit vordefinierten Gren fllen
      String groessen[] = {"8", "9", "10", "11", "12", "14", "16",
                           "18", "20", "22", "24", "26", "28",
                           "36", "48", "72"  };
      groessenListe.setBounds(new Rectangle(270, 10, 100, 100));
      for(int i = 0; i < groessen.length; ++i)
         groessenListe.add(groessen[i]);
      groessenListe.select(0);

      btnFett.setBounds(new Rectangle(270, 120, 100, 25));
      btnFett.setFont(new java.awt.Font("Dialog", 1, 12));
      btnFett.setText("Fett");
      btnKursiv.setBounds(new Rectangle(270, 150, 100, 25));
      btnKursiv.setFont(new java.awt.Font("Dialog", 2, 12));
      btnKursiv.setText("Kursiv");

      btnOK.setBounds(new Rectangle(63, 204, 115, 25));
      btnOK.setText("OK");
      this.getRootPane().setDefaultButton(btnOK);
      btnOK.addActionListener(this);

      btnAbbrechen.setBounds(new Rectangle(210, 204, 115, 25));
      btnAbbrechen.setText("Abbrechen");
      btnAbbrechen.addActionListener(this);

      this.getContentPane().add(fontListe, null);
      this.getContentPane().add(groessenListe, null);
      this.getContentPane().add(btnFett, null);
      this.getContentPane().add(btnKursiv, null);
      this.getContentPane().add(btnAbbrechen, null);
      this.getContentPane().add(btnOK, null);
   }

   // Ereignisbehandlung
   public void actionPerformed(ActionEvent e)  {
      String label = e.getActionCommand();

      if(label.equals("OK"))  {
         String name = fontListe.getSelectedItem();
         int groesse = Integer.parseInt(groessenListe.getSelectedItem());
         int stil = Font.PLAIN;
         if (btnFett.isSelected())
            stil |= Font.BOLD;
         if (btnKursiv.isSelected())
            stil |= Font.ITALIC;

         ausgewaehlterFont = new Font(name, stil, groesse);
         setVisible(false);

      } else if(label.equals("Abbrechen"))  {
         ausgewaehlterFont = null;
         setVisible(false);
      }
   }

   public Font getSchriftart() {
      return ausgewaehlterFont;
   }
}