/* Java-Millionenspiel
 *
 * @(#)Hauptfenster.java    1.0  02/10/20/  Dirk und Peter
 *
 * 
 */

package millionenquiz;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


/**
 * Hauptfenster der Anwendung
 */
public class Hauptfenster extends JFrame {
   MillionenspielPanel leinwand = new MillionenspielPanel(this);
   Spiellogik spiel = new Spiellogik();

   JMenuBar menu = new JMenuBar();
   JMenu menuDatei = new JMenu();
   JMenuItem menuDateiNeu = new JMenuItem();
   JMenuItem menuDateiBeenden = new JMenuItem();

   public Hauptfenster() {
      super();

      try {
         fensterEinrichten();

         // erste Frage einblenden
         spiel.fragen[spiel.aktFrage].anzeigen(leinwand);
      }
      catch(Exception e) {
         e.printStackTrace();
      }
   }

   //Initialisierung der Komponenten
   private void fensterEinrichten() throws Exception  {

      // Anwendungssymbol einrichten
      java.net.URL tmp = Hauptfenster.class.getResource("symbol.gif");
      if (tmp != null)
         setIconImage(Toolkit.getDefaultToolkit().createImage(tmp));

      leinwand.setSize(600, 400);
      getContentPane().add(leinwand);
      this.setSize(new Dimension(600, 400));
      this.setTitle("Das Java-Millionenquiz");
      this.setResizable(false);

      // Men
      menuDatei.setText("Datei");
      menuDateiNeu.setText("Neues Spiel");
      menuDateiNeu.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
           menuDateiNeu_actionPerformed(e);
         }
      });
      menuDateiBeenden.setText("Beenden");
      menuDateiBeenden.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
           menuDateiBeenden_actionPerformed(e);
         }
      });
      menuDatei.add(menuDateiNeu);
      menuDatei.add(menuDateiBeenden);
      menu.add(menuDatei);
      this.setJMenuBar(menu);

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }

   // Ereignisbehandlung fr Menbefehle
   public void menuDateiNeu_actionPerformed(ActionEvent e) {
      JLabel tmp;
      spiel.gewinnstufe = 0;
      spiel.aktFrage    = 0;
      spiel.fragen[spiel.aktFrage].anzeigen(leinwand);

      leinwand.btnOption1.setEnabled(true);
      leinwand.btnOption2.setEnabled(true);
      leinwand.btnOption3.setEnabled(true);
      leinwand.btnOption4.setEnabled(true);

      for(int i = spiel.COMPONENT_BIAS; i < (spiel.COMPONENT_BIAS + spiel.ANZAHL_FRAGEN); ++i) {
         tmp = (JLabel) leinwand.getComponent(i);
         tmp.setForeground(Color.ORANGE);
      }
   }
   public void menuDateiBeenden_actionPerformed(ActionEvent e) {
      System.exit(0);
   }
   protected void processWindowEvent(WindowEvent e) {
      super.processWindowEvent(e);
      if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         menuDateiBeenden_actionPerformed(null);
      }
   }
}


class MillionenspielPanel extends JPanel {
   Image hintergrundbild;
   Hauptfenster hf;

   JLabel lbTitel = new JLabel();
   JTextArea taFrage = new JTextArea();

   JButton btnOption1 = new JButton();
   JButton btnOption2 = new JButton();
   JButton btnOption3 = new JButton();
   JButton btnOption4 = new JButton();

   JLabel stufe1 = new JLabel();
   JLabel stufe2 = new JLabel();
   JLabel stufe3 = new JLabel();
   JLabel stufe4 = new JLabel();
   JLabel stufe5 = new JLabel();
   JLabel stufe6 = new JLabel();
   JLabel stufe7 = new JLabel();
   JLabel stufe8 = new JLabel();

   MillionenspielPanel(Hauptfenster fenster) {
      hf = fenster;

      // Bild laden mit getResource(), siehe Kapitel 32.1.3
      //                               und Kapitel 39.4.1
      Toolkit toolkit = Toolkit.getDefaultToolkit();
      MediaTracker ladekontrolle = new MediaTracker(this);

      hintergrundbild = getToolkit().getImage(getClass().getResource("Hintergrund.png"));

      ladekontrolle.addImage(hintergrundbild,0);

      // Warten, bis das Bild ganz geladen ist
      try  {
         ladekontrolle.waitForID(0);
      }
      catch(InterruptedException e) {
         // Das Laden ist fehlgeschlagen
      }

      this.setLayout(null);

      lbTitel.setFont(new java.awt.Font("Dialog", 1, 28));
      lbTitel.setForeground(Color.ORANGE);
      lbTitel.setHorizontalAlignment(SwingConstants.CENTER);
      lbTitel.setText("DAS JAVA-MILLIONENSPIEL");
      lbTitel.setBounds(new Rectangle(36, 12, 510, 37));
      taFrage.setFont(new java.awt.Font("Dialog", 1, 16));
      taFrage.setForeground(Color.WHITE);
      taFrage.setOpaque(false);
      taFrage.setEditable(false);
      taFrage.setColumns(2);
      taFrage.setLineWrap(true);
      taFrage.setBounds(new Rectangle(20, 70, 470, 80));

      btnOption1.setBounds(new Rectangle(40, 240, 200, 40));
      btnOption1.setContentAreaFilled(false);
      btnOption1.setForeground(Color.WHITE);
      btnOption1.setFont(new java.awt.Font("Dialog", 1, 18));
      btnOption1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            btnOption1_actionPerformed(e);
         }
      });
      btnOption2.setBounds(new Rectangle(250, 240, 200, 40));
      btnOption2.setContentAreaFilled(false);
      btnOption2.setForeground(Color.WHITE);
      btnOption2.setFont(new java.awt.Font("Dialog", 1, 18));
      btnOption2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            btnOption2_actionPerformed(e);
         }
      });
      btnOption3.setBounds(new Rectangle(40, 300, 200, 40));
      btnOption3.setContentAreaFilled(false);
      btnOption3.setForeground(Color.WHITE);
      btnOption3.setFont(new java.awt.Font("Dialog", 1, 18));
      btnOption3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            btnOption3_actionPerformed(e);
         }
      });
      btnOption4.setBounds(new Rectangle(250, 300, 200, 40));
      btnOption4.setContentAreaFilled(false);
      btnOption4.setForeground(Color.WHITE);
      btnOption4.setFont(new java.awt.Font("Dialog", 1, 18));
      btnOption4.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            btnOption4_actionPerformed(e);
         }
      });

      stufe1.setBounds(new Rectangle(450, 300, 130, 20));
      stufe1.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe1.setForeground(Color.ORANGE);
      stufe1.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe1.setText("5000");
      stufe2.setBounds(new Rectangle(450, 270, 130, 20));
      stufe2.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe2.setForeground(Color.ORANGE);
      stufe2.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe2.setText("10000");
      stufe3.setBounds(new Rectangle(450, 240, 130, 20));
      stufe3.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe3.setForeground(Color.ORANGE);
      stufe3.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe3.setText("25000");
      stufe4.setBounds(new Rectangle(450, 210, 130, 20));
      stufe4.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe4.setForeground(Color.ORANGE);
      stufe4.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe4.setText("50000");
      stufe5.setBounds(new Rectangle(450, 180, 130, 20));
      stufe5.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe5.setForeground(Color.ORANGE);
      stufe5.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe5.setText("100000");
      stufe6.setBounds(new Rectangle(450, 150, 130, 20));
      stufe6.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe6.setForeground(Color.ORANGE);
      stufe6.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe6.setText("250000");
      stufe7.setBounds(new Rectangle(450, 120, 130, 20));
      stufe7.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe7.setForeground(Color.ORANGE);
      stufe7.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe7.setText("500000");
      stufe8.setBounds(new Rectangle(450, 94, 130, 20));
      stufe8.setFont(new java.awt.Font("Dialog", 1, 18));
      stufe8.setForeground(Color.ORANGE);
      stufe8.setHorizontalAlignment(SwingConstants.RIGHT);
      stufe8.setText("1000000");

      add(lbTitel, null);
      add(taFrage, null);
      add(btnOption1, null);
      add(btnOption2, null);
      add(btnOption3, null);
      add(btnOption4, null);
      add(stufe1, null);
      add(stufe2, null);
      add(stufe3, null);
      add(stufe4, null);
      add(stufe5, null);
      add(stufe6, null);
      add(stufe7, null);
      add(stufe8, null);
   }

   public void paintComponent(Graphics g) {
      super.paintComponent(g);
      g.drawImage(hintergrundbild, 0, 0, getWidth(), getHeight(), this);
  }

   void btnOption1_actionPerformed(ActionEvent e) {
      hf.spiel.auswerten(1, this);
   }
   void btnOption2_actionPerformed(ActionEvent e) {
      hf.spiel.auswerten(2, this);
   }
   void btnOption3_actionPerformed(ActionEvent e) {
      hf.spiel.auswerten(3, this);
   }
   void btnOption4_actionPerformed(ActionEvent e) {
      hf.spiel.auswerten(4, this);
   }
}

