/* Java-Millionenspiel
 *
 * @(#)Spiellogik.java    1.0  02/10/20/  Dirk und Peter
 *
 * 
 */

package millionenquiz;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


class Frage {
   private String frage;
   private String option1;
   private String option2;
   private String option3;
   private String option4;
   private int loesung;

   public Frage(String f, String o1, String o2, String o3, String o4, int l) {
      frage = f;
      option1 = o1;
      option2 = o2;
      option3 = o3;
      option4 = o4;
      loesung = l;
   }

   public void anzeigen(MillionenspielPanel leinwand) {
      leinwand.taFrage.setText(frage);
      leinwand.btnOption1.setText(option1);
      leinwand.btnOption2.setText(option2);
      leinwand.btnOption3.setText(option3);
      leinwand.btnOption4.setText(option4);
   }

   public boolean auswerten(int ausgewaehlt) {
      if (ausgewaehlt == this.loesung)
         return true;
      else
         return false;
   }
}

class Spiellogik {
   final int ANZAHL_FRAGEN = 8;
   final int COMPONENT_BIAS = 6; // nullbasiert

   Frage[] fragen = new Frage[ANZAHL_FRAGEN];
   byte aktFrage = 0;
   int gewinnstufe = 0;

   Spiellogik() {
      // Fragen erzeugen
      fragen[0] = new Frage("Ist Java...",
                            "desorientiert", "objektorientiert", "blamiert", "pervertiert", 2);
      fragen[1] = new Frage("Wie hie der Vorgnger von Java?",
                             "Cloak", "Eiche", "Willow", "Oak", 4);
      fragen[2] = new Frage("Mit welchem Schlsselwort werden in Java Objekte \nerzeugt?",
                            "new", "create", "erzeuge", "old", 1);
      fragen[3] = new Frage("Mit welchem Schlsselwort werden in Java konstante\nVariablen deklariert?",
                            "konstant", "const", "final", "immutable", 3);
      fragen[4] = new Frage("Wie lautet der Wert folgenden Ausdrucks: \n2d + 3 / 4?",
                            "2", "2.75", "3", "1.25", 2);
      fragen[5] = new Frage("Nach welchem Algorithmus sortiert Arrays.sort() \nObjekte?",
                            "Bubblesort", "Shellsort", "Mergesort", "Quicksort", 3);
      fragen[6] = new Frage("Seit welcher Version gibt es die Swing-Klassen?",
                            "1.0", "1.1", "1.2", "1.3", 3);
      fragen[7] = new Frage("Seit wann ist Java unabhngig?",
                            "1843", "1945", "1947", "1949", 4);
   }

   void auswerten(int schalter, MillionenspielPanel leinwand) {
      JLabel tmp;

      if (!fragen[aktFrage].auswerten(schalter)) {  // falsch beantwortet
         if (gewinnstufe == 0)
             JOptionPane.showMessageDialog(null,
                                          "Leider nichts gewonnen.  :-(",
                                          "Schade!", 1);
          else
             JOptionPane.showMessageDialog(null,
                                          "Sie haben Gewinnstufe " + gewinnstufe + " erreicht!  :-)",
                                          "Glckwunsch!!!", 1);
         // Schalter deaktivieren
         leinwand.btnOption1.setEnabled(false);
         leinwand.btnOption2.setEnabled(false);
         leinwand.btnOption3.setEnabled(false);
         leinwand.btnOption4.setEnabled(false);
      } else if (aktFrage < ANZAHL_FRAGEN-1) {
         fragen[++aktFrage].anzeigen(leinwand);

         tmp = (JLabel) leinwand.getComponent(gewinnstufe + COMPONENT_BIAS);
         tmp.setForeground(new Color(0x00FFFF));
         gewinnstufe++;
       }
       else {
         tmp = (JLabel) leinwand.getComponent(gewinnstufe + COMPONENT_BIAS);
         tmp.setForeground(new Color(0x00FFFF));
         gewinnstufe++;
             JOptionPane.showMessageDialog(null, "Glckwunsch, Sie haben den Jackpot geknackt!!!", "Wow!!!", 1);
         // Schalter deaktivieren
         leinwand.btnOption1.setEnabled(false);
         leinwand.btnOption2.setEnabled(false);
         leinwand.btnOption3.setEnabled(false);
         leinwand.btnOption4.setEnabled(false);
      }
   }
}