/*
 * FraktalDemoThread.java - Fraktalberechnung mit Threads
 *
 */

import java.awt.*;
import java.awt.geom.*; 
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class FraktalDemoThread  {
  public static void main(String[] args) {
    FraktalFenster fenster = new FraktalFenster();
    fenster.validate();
    fenster.setVisible(true);
  }
}
 
class FraktalFenster extends JFrame implements ActionListener {
   private JPanel contentPane;
   private JPanel canvas;
   private FraktalThread fraktal;
   private BorderLayout borderLayout = new BorderLayout();

   // Konstruktor
   public FraktalFenster() {
      contentPane = (JPanel) this.getContentPane();
      contentPane.setLayout(borderLayout);
      setSize(new Dimension(400, 400));
      setResizable(false);
      setTitle("Fraktal-Demo");
   
      JPanel tmp = new JPanel();
      JButton start = new JButton("Start");
      JButton stop  = new JButton("Stopp");
      start.addActionListener(this);
      stop.addActionListener(this); 
      tmp.add(start);
      tmp.add(stop);
      contentPane.add(tmp,BorderLayout.SOUTH); 

      canvas = new JPanel();
      canvas.setSize(400,300); 
      canvas.setBackground(Color.BLACK); 
      contentPane.add(canvas, BorderLayout.CENTER); 
      
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);      
   }


   public void actionPerformed(ActionEvent e)  {
      String cmd = e.getActionCommand();

      if((cmd.equals("Start") == true) && (fraktal == null))  {
         fraktal = new FraktalThread(canvas);
         fraktal.start(); 
      }

      if((cmd.equals("Stopp") == true) && (fraktal != null))  {
         fraktal.stoppen(); 
         fraktal = null;
      }
   }
}

class FraktalThread extends Thread {
   private boolean weiter = true;
   private JPanel canvas;

   FraktalThread(JPanel canvas)  {
      this.canvas = canvas;
   }

   public void stoppen()  {
      weiter = false; 
   }

   public void run() {
      lorenzFarbig(); 
   }

   private void lorenzFarbig() {
      double a = 10.0;
      double b = 8 / 3;
      double c = 28.0;
      double d = 0.003;

      double x_neu,x_alt, y_neu, y_alt, z_neu, z_alt;
      int pos_x, pos_y;

      x_alt = 0.1;
      y_alt = 0.1;
      z_alt = 0.5;

      Graphics g = canvas.getGraphics();    
      g.setColor(Color.BLACK);
      g.fillRect(0,0,400,400);
      g.setColor(Color.RED); 

      int num = 0;

      Color[] farben = new Color[5];

      farben[0] = Color.RED;
      farben[1] = Color.GREEN;
      farben[2] = Color.PINK;
      farben[3] = Color.YELLOW;
      farben[4] = Color.BLUE; 
   
      Random wrfel = new Random();

      while(weiter)  {
         x_neu = x_alt + d * a * (y_alt - x_alt);    
         y_neu = y_alt + d * (x_alt * (c - z_alt) - y_alt);
         z_neu = z_alt + d * (x_alt * y_alt - b * z_alt);

         pos_x = (int) (200 + x_neu * 100);
         pos_y = (int) (250 + y_neu * 100);

         if(pos_x >= 0 && pos_x <= 400 && pos_y >= 0 && pos_y <= 400) { 
            g.fillRect(pos_x, pos_y, 1 , 1 ); 
            num++;
             
            if(num > 50000) {
               int farbe = wrfel.nextInt(5); 
               g.setColor(farben[farbe]); 
               num = 0; 
            }
         }

         x_alt = x_neu;
         y_alt = y_neu;
         z_alt = z_neu;
      }
   }
}
