/*
 * TimerDemo.java - Einsatz von Timer
 *
 */

import javax.swing.*; 
import java.awt.*;
import java.awt.event.*;

public class TimerDemo {
   public static void main(String[] args)  {
     Fenster f = new Fenster();
     f.setVisible(true);
   }
}

class Fenster extends JFrame  {
   private JPanel contentPane;
   private FlowLayout flowLayout = new FlowLayout();
   public JButton start = new JButton();

   class ActionLauscher implements ActionListener  {
      private Fenster fenster;
      private Timer meinTimer; 
      private FarbWechsler blinker; 

      public ActionLauscher(Fenster f)  {
         fenster = f; 
      }

      public void actionPerformed(ActionEvent e)  {
         if(meinTimer == null)  {
            start.setText("Stopp");
            blinker = new FarbWechsler();
            meinTimer = new Timer(1000,blinker); 
            meinTimer.start(); 
            System.out.println(" gestartet"); 
         } else  {
            start.setText("Start");
            meinTimer.stop(); 
            meinTimer = null;
            System.out.println(" gestoppt"); 
         }
      }

      class FarbWechsler implements ActionListener  {
         public void actionPerformed(ActionEvent e) {
            if(fenster.start.getBackground() == Color.RED)  
               fenster.start.setBackground(Color.GREEN); 
            else
               fenster.start.setBackground(Color.RED); 
         }
      }
   }


   public Fenster() {
      super();
      contentPane = (JPanel) this.getContentPane();
      contentPane.setLayout(flowLayout);

      start.setText("Start"); 
      start.addActionListener(new ActionLauscher(this));
      start.setBackground(Color.RED); 


      setSize(new  Dimension(300,100));
      setTitle("Timer und Swing");
      contentPane.add(start,null); 
   }

   protected void processWindowEvent(WindowEvent e) {
      super.processWindowEvent(e);
      if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         System.exit(0);
      }
   }
}

