/*
 * PipeKommunikation.java - Thread-Kommunikation per Pipe
 *
 */

import java.util.*;
import java.io.*; 

public class PipeKommunikation  {
   public static void main(String[] args)  {
      try  {
         PipedWriter schreiben = new PipedWriter();
         PipedReader lesen = new PipedReader(schreiben);

         Produzent prod  = new Produzent(schreiben);
         Verbraucher ver = new Verbraucher(lesen);

         prod.start();
         ver.start();
      } catch(IOException e) {
         System.err.println(e.getMessage()); 
      } 
   }
}

class Produzent extends Thread {
   private PipedWriter diePipe;

   public Produzent(PipedWriter pipe)  {
      super();
      diePipe = pipe;
   }

   public void run() {

      Date tmp;
      try  {
         for(int i = 0; i < 10; i++)  {
            tmp = new Date();
            diePipe.write(tmp.toString() + "\n");
            sleep(2000);
         }

         diePipe.close(); 
      } catch(Exception e) { }
   }
}

class Verbraucher extends Thread {
   private PipedReader diePipe;

   public Verbraucher(PipedReader pipe)  {
      super();
      diePipe = pipe;
   }

   public void run() {

      while(true)  {
         try {
            int c = diePipe.read();
                
            if(c != -1)
               System.out.print((char) c); 
            else
               break; 
         } catch(IOException e) {
            System.err.println(e.getMessage()); 
         } 
      }
   }
}
