/*
 * ProducerConsumer.java - Produzenten-Verbraucher-Beispiel
 *
 */

import java.util.*; 

public class ProducerConsumer  {
   public static void main(String[] args)  {
    
      LinkedList<Date> zeitStempel = new LinkedList<Date>();

      Produzent prod  = new Produzent(zeitStempel);
      Verbraucher ver = new Verbraucher(zeitStempel);

      prod.start();
      ver.start();
   }
}


class Produzent extends Thread {
   private LinkedList<Date> zeitStempel;

   public Produzent(LinkedList<Date> list)  {
      super(); 
      zeitStempel = list;
   }
 
   public void run() {
      Date tmp;

      for(int i = 0; i < 10; i++)  {

         // ein bichen warten
         try  {
            sleep(2000);
         } catch(Exception e) { }

         tmp = new Date();

         synchronized(zeitStempel)  {
            zeitStempel.add(tmp);
            zeitStempel.notify(); 
         }
      }
   }
}


class Verbraucher extends Thread {
   private LinkedList<Date> zeitStempel;

   public Verbraucher(LinkedList<Date> list)  {
      super(); 
      zeitStempel = list;
   }
 
   public void run() {
      Date tmp;

      while(true)  {
         synchronized(zeitStempel) {

            try {
               zeitStempel.wait(5000);
            }
            catch(InterruptedException e) {} 

            if(zeitStempel.size() > 0)  {
               tmp = zeitStempel.removeFirst();
               System.out.println(" Zeitstempel: " + tmp); 
            } else 
               break; 
         }
      }
   }
}
