/*
 * UnsafeThread.java - sychronisierter Thread-Einsatz mit synchronized
 *
 */ 

public class SafeThread  {
   public static void main(String[] args)  {
      System.out.println();

      ZaehlThread zaehl = new ZaehlThread(); 
      KontrollThread kon = new KontrollThread(zaehl);

      zaehl.start();
      kon.start();
   }
}


class ZaehlThread extends Thread  {
   public long x = 0;
   public long y = 0; 

   public void run() {
      while(true)  {
         synchronized(this)  {
            x += 1;
            y += 1;
         }
      }
   }
}

class KontrollThread extends Thread  {
   ZaehlThread zaehler;

   public KontrollThread(ZaehlThread obj)  {
      super(); 
      zaehler = obj; 
   }

   public void run()  {
      long start = System.currentTimeMillis();
      long x, y;


      while(true) {
         synchronized(zaehler)  {
            x = zaehler.x;
            y = zaehler.y; 
         }


         if(x != y) {
            long end = System.currentTimeMillis();
            System.out.println("Unterschied nach " 
                            + (end - start) + " ms"); 
            System.exit(0); 
         } else  {
            System.out.println(x + " , " + y); 
            try { 
               sleep(5); 
            } catch(Exception e) {}
         }
      }
   }
}


