/*
 * URLInfo.java - URL-Informationen abfragen
 *
 */

import java.net.*;
import java.io.*; 

public class URLInfo {
   public static void main(String[] args) {
      System.out.println();
      
      if(args.length != 1)  {
         System.out.println(" Falsche Anzahl Argumente in Befehlszeile");
         System.out.println(" Aufruf: java URLInfo <URL>");
         System.exit(0); 
      }

      // URL anlegen
      try {
         URL url = new URL(args[0]);

         // Infos ausgeben
         System.out.println(" URL        : " + url.toString());
         System.out.println(" Protokoll  : " + url.getProtocol());
         System.out.println(" Hostadresse: " + url.getHost());
         System.out.println(" Portnummer : " + url.getPort());
         System.out.println(" Dateiname  : " + url.getFile());

         System.out.println(" Dateiinhalt   :");

         BufferedReader input = new BufferedReader(
                      new InputStreamReader(url.openStream())); 

         String zeile;

         // den Inhalt des Dokuments zeilenweise lesen
         while ((zeile = input.readLine()) != null)  
            System.out.println(zeile);

         input.close();
      } catch(MalformedURLException e) {
         System.err.println(" Ungueltiger URL!");
         System.exit(0);
      } catch(IOException e) {
         System.err.println(" IOException!");
         System.exit(0);
      }   
   }
}
